--------------------------------------------------------------------
--  DOOM THEMES
--------------------------------------------------------------------
--
--  Copyright (C) 2006-2017 Andrew Apted
--  Copyright (C) 2011,2019, 2021-2022 Armaetus
--  Copyright (C) 2019-2022 MsrSgtShooterPerson
--
--  This program is free software; you can redistribute it and/or
--  modify it under the terms of the GNU General Public License
--  as published by the Free Software Foundation; either version 2,
--  of the License, or (at your option) any later version.
--
--------------------------------------------------------------------


DOOM.SINKS =
{
  -- sky holes --

  sky_plain =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,
  },

  sky_metal =
  {
    mat   = "_SKY",
    dz    = 48,
    light = 16,

    trim_mat = "METAL",
    trim_dz  = -9,
    trim_light = 16,
  },

  sky_shiny =
  {
    mat   = "_SKY",
    dz    = 32,
    light = 16,

    trim_mat = "FLAT23",
    trim_dz  = -5,
    trim_light = 16,
  },

  sky_red =
  {
    mat   = "_SKY",
    dz    = 32,
    light = 16,

    trim_mat = "REDWALL",
    trim_dz  = -5,
    trim_light = 16,
  },


  sky_tech1 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "STARBR2",
    trim_dz  = 0,
  },

  sky_tech2 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "STARG2",
    trim_dz  = 0,
  },

  sky_tech3 =
  {
    mat   = "_SKY",
    dz    = 144,
    light = 16,

    trim_mat = "COMPTALL",
    trim_dz  = 16,
  },


  sky_urban_1 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "WOOD4",
    trim_dz  = 0,
  },

  sky_urban_2 =
  {
    mat   = "_SKY",
    dz    = 72,
    light = 16,

    trim_mat = "BRONZE1",
    trim_dz  = 0,
  },

  sky_urban_3 =
  {
    mat   = "_SKY",
    dz    = 96,
    light = 16,

    trim_mat = "SLADSKUL",
    trim_dz  = 0,
  },


  sky_hell_1 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "WOODMET2",
    trim_dz  = 0,
  },

  sky_hell_2 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "SKINSYMB",
    trim_dz  = 0,
  },

  sky_hell_3 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "BIGBRIK2",
    trim_dz  = 0,
  },

-- sky ceilings

  sky_hell_4 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "MARBFAC4",
    trim_dz  = 0,
  },

  sky_bronze =
  {
    mat   = "_SKY",
    dz    = 48,
    light = 16,

    trim_mat = "BRONZE1",
    trim_dz  = -9,
    trim_light = 16,
  },

  sky_metal2 =
  {
    mat   = "_SKY",
    dz    = 48,
    light = 16,

    trim_mat = "METAL2",
    trim_dz  = -9,
    trim_light = 16,
  },

  sky_pipes =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "PIPEWAL2",
    trim_dz  = 0,
  },

  sky_hell_5 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "BIGBRIK1",
    trim_dz  = 0,
  },

  sky_tech4 =
  {
    mat   = "_SKY",
    dz    = 144,
    light = 16,

    trim_mat = "TEKWALL4",
    trim_dz  = 16,
  },

  sky_stone_1 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "STONE2",
    trim_dz  = 0,
  },

  sky_stone_2 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "STONE3",
    trim_dz  = 0,
  },

  sky_hell_6 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "WOODMET4",
    trim_dz  = 0,
  },

  sky_hell_7 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GSTVINE1",
    trim_dz  = 0,
  },

  sky_hell_8 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GSTVINE2",
    trim_dz  = 0,
  },

  sky_hell_9 =
  {
    mat   = "_SKY",
    dz    = 80,
    light = 16,

    trim_mat = "SP_FACE1",
    trim_dz  = 0,
  },

  sky_tech5 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GRAYTALL",
    trim_dz  = 16,
  },

  sky_tech6 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "BROVINE2",
    trim_dz  = 16,
  },

  sky_tech7 =
  {
    mat   = "_SKY",
    dz    = 48,
    light = 16,

    trim_mat = "SHAWN3",
    trim_dz  = 16,
  },

  sky_tech8 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "METAL1",
    trim_dz  = 16,
  },

  sky_tech9 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GRAYBIG",
    trim_dz  = 16,
  },

  sky_cement =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "CEMENT9",
    trim_dz  = 16,
  },

  sky_brick10 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "BRICK10",
    trim_dz  = 16,
  },

  sky_brownpip =
  {
    mat   = "_SKY",
    dz    = 112,
    light = 16,

    trim_mat = "BROWNPIP",
    trim_dz  = 16,
  },

  sky_crackle1 =
  {
    mat   = "_SKY",
    dz    = 80,
    light = 16,

    trim_mat = "CRACKLE2",
    trim_dz  = 16,
  },

  sky_crackle2 =
  {
    mat   = "_SKY",
    dz    = 64,
    light = 16,

    trim_mat = "CRACKLE4",
    trim_dz  = 16,
  },

  sky_fireblu =
  {
    mat   = "_SKY",
    dz    = 80,
    light = 32,

    trim_mat = "FIREBLU2",
    trim_dz  = 16,
  },

  sky_modwall =
  {
    mat   = "_SKY",
    dz    = 80,
    light = 16,

    trim_mat = "MODWALL3",
    trim_dz  = 16,
  },

  sky_hell_10 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GSTGARG",
    trim_dz  = 16,
  },

  sky_hell_11 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GSTLION",
    trim_dz  = 16,
  },

  sky_hell_12 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "GSTSATYR",
    trim_dz  = 16,
  },

  sky_hell_13 =
  {
    mat   = "_SKY",
    dz    = 96,
    light = 16,

    trim_mat = "SKSPINE2",
    trim_dz  = 16,
  },

  sky_hell_14 =
  {
    mat   = "_SKY",
    dz    = 128,
    light = 16,

    trim_mat = "SKINCUT",
    trim_dz  = 16,
  },

  sky_hell_15 =
  {
    mat   = "_SKY",
    dz    = 104,
    light = 16,

    trim_mat = "SKINLOW",
    trim_dz  = 0,
  },

  -- liquid floor --

  liquid_plain =
  {
    mat = "_LIQUID",
    dz  = -12,
  },

  liquid_blood =
  {
    mat = "BLOOD1",
    dz  = -12,
    --light = 16,
  },

  liquid_shiny =
  {
    mat = "_LIQUID",
    dz  = -8,

    trim_mat = "FLAT23",
    trim_dz  = 0,
  },

  liquid_metal =
  {
    mat = "_LIQUID",
    dz  = -8,

    trim_mat = "METAL",
    trim_dz  = 0,
  },

  liquid_marble =
  {
    mat = "_LIQUID",
    dz  = -12,

    trim_mat = "MARBGRAY",
    trim_dz  = 0,
  },

  liquid_ash =
  {
    mat = "_LIQUID",
    dz  = -10,

    trim_mat = "ASHWALL3",
    trim_dz  = 2,
  },

  liquid_firelava =
  {
    mat = "_LIQUID",
    dz  = -8,
    light = 40,

    trim_mat = "FIREBLU1",
    trim_dz  = 2,
  },

  liquid_metal2 =
  {
    mat = "_LIQUID",
    dz  = -8,

    trim_mat = "METAL2",
    trim_dz  = 0,
  },

  liquid_bstone =
  {
    mat = "_LIQUID",
    dz  = -8,

    trim_mat = "BSTONE1",
    trim_dz  = 2,
  },

  liquid_bstone2 =
  {
    mat = "_LIQUID",
    dz  = -8,

    trim_mat = "BSTONE2",
    trim_dz  = 2,
  },

  -- ceiling lights --

  light_red_shiny =
  {
    mat = "TLITE6_5",
    dz  = 4,
    light = 16,

    trim_mat = "FLAT23",
    trim_dz  = -5,
  },

  light_orange_shiny =
  {
    mat = "TLITE6_6",
    dz  = 4,
    light = 16,

    trim_mat = "FLAT23",
    trim_dz  = -5,
  },

  light_brightred_metal =
  {
    mat = "FLOOR1_7",
    dz  = 8,
    light = 32,

    trim_mat = "METAL",
    trim_dz  = -5,
    trim_light = 16,
  },

  light_brightred_metal2 =
  {
    mat = "FLOOR1_7",
    dz  = 8,
    light = 32,

    trim_mat = "SHAWN2",
    trim_dz  = -5,
    trim_light = 16,
  },

  light_diamond =
  {
    mat = "TLITE6_1",
    dz  = 8,
    light = 16,
  },

  light_urban1 =
  {
    mat = "CEIL3_4",
    dz  = 4,
    light = 32,

    trim_mat = "METAL",
    trim_dz  = -5,
  },

  light_hell_red =
  {
    mat = "FLAT5_3",
    dz  = 16,
    light = 16,
  },

  light_hell_lava =
  {
    mat = "LAVA1",
    dz  = 16,
    light = 32,
  },

  light_side1 =
  {
    mat = "CEIL4_3",
    dz  = 16,
    light = 32,

    trim_mat = "LITE5",
    trim_dz  = 0,
  },

  light_side2 =
  {
    mat = "SLIME15",
    dz  = 16,
    light = 16,

    trim_mat = "LITE5",
    trim_dz  = 0,
  },

  light_side3 =
  {
    mat = "CEIL5_1",
    dz  = 16,
    light = 32,

    trim_mat = "METAL7",
    trim_dz  = 0,
  },

  light_side4 =
  {
    mat = "CEIL4_2",
    dz  = 16,
    light = 32,

    trim_mat = "LITE5",
    trim_dz  = 0,
  },

  light_side5 =
  {
    mat = "SLIME14",
    dz  = 16,
    light = 16,

    trim_mat = "LITE5",
    trim_dz  = 0,
  },

  light_side6 =
  {
    mat = "CEIL5_2",
    dz  = 24,
    light = 24,

    trim_mat = "BRONZE4",
    trim_dz  = 0,
  },

  -- misc floor --

  floor_glowingrock =
  {
    mat = "RROCK05",
    dz  = -8,
  },

  floor_skulls =
  {
    mat = "FLAT5_6",
    dz  = -8,
  },

  floor_snakes =
  {
    mat = "SFLR6_4",
    dz  = -8,
  },

  floor_green =
  {
    mat = "DEM1_5",
    dz  = -8,
  },

  floor_red =
  {
    mat = "FLOOR6_1",
    dz  = -8,
  },

  floor_blue =
  {
    mat = "FLAT14",
    dz  = -8,
  },

  floor_blue2 =
  {
    mat = "CEIL4_3",
    dz  = -8,
  },

  floor_glowingrock2 =
  {
    mat = "SLIME09",
    dz  = -8,
  },

  floor_blue3 =
  {
    mat = "CEIL4_2",
    dz  = -8,
  },

  floor_green2 =
  {
    mat = "DEM1_6",
    dz  = -8,
  },

  floor_dirt1 =
  {
    mat = "RROCK16",
    dz  = -8,
  },

  floor_dirt2 =
  {
    mat = "RROCK17",
    dz  = -8,
  },

  floor_dirt3 =
  {
    mat = "RROCK18",
    dz  = -8,
  },

  floor_snakes2 =
  {
    mat = "SFLR6_1",
    dz  = -8,
  },

  -- misc ceiling --

  ceil_redash =
  {
    mat = "FLOOR6_1",
    dz  = 8,
  },

  ceil_vdark =
  {
    mat   = "CEIL4_1",
    dz    = 64,

    trim_mat = "BLAKWAL2",
    trim_dz  = 0,
  },

   ceil_vdark2 =
  {
    mat   = "CEIL4_1",
    dz    = 64,

    trim_mat = "COMPSPAN",
    trim_dz  = 0,
  },

  ceil_icky =
  {
    mat   = "FLAT5_4",
    dz    = 64,

    trim_mat = "ICKWALL1",
    trim_dz  = 64,
  },

  ceil_glowrock =
  {
    mat = "RROCK05",
    dz    = 64,
    light = 16,

    trim_mat = "ROCKRED1",
    trim_dz  = -8,
  },

  ceil_glowrock2 =
  {
    mat = "SLIME09",
    dz    = 64,
    light = 16,

    trim_mat = "ROCKRED1",
    trim_dz  = -8,
  },

  ceil_hotrock =
  {
    mat = "RROCK01",
    dz    = 64,
    light = 24,

    trim_mat = "SP_HOT1",
    trim_dz  = -8,
  },

  ceil_hotrock2 =
  {
    mat = "RROCK02",
    dz    = 64,
    light = 24,

    trim_mat = "SP_HOT1",
    trim_dz  = -8,
  },

  ceil_water =
  {
    mat = "FWATER1",
    dz    = 64,

    trim_mat = "STONE2",
    trim_dz  = -8,
  },

  ceil_blood =
  {
    mat = "BLOOD1",
    dz    = 64,

    trim_mat = "STONE3",
    trim_dz  = -8,
  },

  ceil_sprock =
  {
    mat = "MFLR8_3",
    dz    = 64,
    light = 24,

    trim_mat = "SP_ROCK1",
    trim_dz  = -8,
  },

  -- fantastic floors
  floor_sky =
  {
    mat = "_SKY",
    dz = -16,
    light = 32,

    trim_mat = "FLOOR7_2",
    trim_dz = -8,
  },

  floor_trim_sky =
  {
    mat = "_FLOOR",

    trim_mat = "_SKY",
    trim_dz = -8,
  },

  floor_trim_liquid =
  {
    mat = "_FLOOR",
    dz = -4,

    trim_mat = "_LIQUID",
    trim_dz = -8,
  },

  floor_mixup =
  {
    mat = "_CEIL",
    dz = -8,

    trim_mat = "_WALL",
    trim_dz = -4,
  },

  floor_shawn_wall =
  {
    mat = "_WALL",
    dz = -8,

    trim_mat = "SHAWN2",
    trim_dz = -4,
  },

  floor_metal_wall =
  {
    mat = "_WALL",
    dz = -8,

    trim_mat = "METAL",
    trim_dz = -4,
  },

  floor_shawn_c =
  {
    mat = "_CEIL",
    dz = -8,

    trim_mat = "SHAWN2",
    trim_dz = -4,
  },

  floor_metal_c =
  {
    mat = "_CEIL",
    dz = -8,

    trim_mat = "METAL",
    trim_dz = -4,
  },

  -- street sink def, do not use for anything else
  floor_default_streets =
  {
    mat = "CEIL5_1",
    dz = 2,

    trim_mat = "FLAT1",
    trim_dz = 2,
  },
}



DOOM.THEMES =
{
  DEFAULTS =
  {
    keys =
    {
      k_red    = 50,
      k_blue   = 50,
      k_yellow = 50,
    },

    barrels =
    {
      barrel = 50,
    },

    passable_decor =
    {
      gibs = 20,
      pool_blood_1 = 20,
      pool_blood_2 = 20,
      pool_brains  = 10,

      gibbed_player = 10,
      dead_player = 10,
      dead_zombie = 3,
      dead_shooter = 3,
      dead_imp = 3,
      dead_demon = 1,
      dead_caco  = 1,
    },

    cave_torches =
    {
      red_torch = 50,
    },

    cliff_trees =
    {
      burnt_tree = 80,
      brown_stub = 40,
        big_tree = 20,
    },

    park_decor =
    {
      burnt_tree = 80,
      brown_stub = 40,
        big_tree = 20,
    },

    fences =
    {
      STONE = 50,
    },

    narrow_halls =
    {
      vent = 50,
      mineshaft = 50,
    },

    wide_halls =
    {
      deuce = 50,
      metro = 50,
    },

    floor_sinks =
    {
      PLAIN = 0.01,
    },

    ceiling_sinks =
    {
      PLAIN = 0.01,
    },

    wall_groups =
    {
      PLAIN = 0.01,
    },

    window_groups =
    {
      square = 100,
    },

    -- FIXME: temp crud
    has_triple_key_door = true,
    has_double_switch_door = true,

    steps_mat = "GRAY7",

    cage_mats =
    {
      METAL1   = 60,
      BROWN144 = 60,
      ICKWALL3 = 60,

      STONE    = 20,
      SLADWALL = 20,
      WOODVERT = 20
    },

    streets_friendly = false
  },

  ------------------------------------

  tech =
  {

    wide_halls = -- Added empty table to use with themes_alt function - Dasho
    {

    },

    narrow_halls =
    {
      vent = 50,
      mineshaft = 50,
      access = 50
    },

    liquids =
    {
      nukage = 70,
      water  = 30,
      slime  = 10,
      lava   = 5
    },

    facades =
    {
      BROWN1   = 80,
      BROWNGRN = 40,
      STARGR1  = 30,
      STARG1   = 30,
      STARG3   = 40,
      STARTAN3 = 50,
      STONE    = 30,
      STONE2   = 30,
      STONE3   = 30,
      TEKGREN2 = 25,
      BROVINE2 = 5,
      GRAY7    = 15,
      GRAYVINE = 5,

      BROWN96  = 20,
      METAL2   = 15,
      BRONZE1  = 15,
      BRONZE3  = 15,
      METAL1   = 10,
      SLADWALL = 20,

      GRAY1 = 40,
      GRAY4 = 40,
      GRAY5 = 40
    },

    fences =
    {
      BROWN144 = 60,
      STONE    = 40,
      STONE2   = 40,
      STONE3   = 30,
      STONE4   = 30,
      METAL2   = 30,
      BRONZE1  = 30,
      SLADWALL = 30,

      CEMENT9  = 10,
      BRICK10  = 10,
      METAL1   = 10,

      GRAY5 = 50,
      GRAY7 = 50
    },

    cage_mats =
    {
      METAL1   = 60,
      METAL2   = 60,
      BROWN144 = 60,
      STONE    = 60,
      ICKWALL2 = 40,
      ICKWALL3 = 40,
      SILVER1  = 40,
      BROWNHUG = 40,
      SHAWN2   = 40,
      TEKWALL1 = 40,
      TEKWALL4 = 40,

      GRAY4    = 20,
      GRAYBIG  = 20,
      PIPEWAL2 = 20,
      STONE    = 20,
      STONE2   = 20,
      STONE4   = 20,
      TEKLITE  = 20
    },

    prefab_remap =
    {
    },

    entity_remap =
    {
      green_torch = "mercury_lamp"
    },

    street_sinks =
    {
      floor_default_streets = 1
    },

    floor_sinks =
    {
      liquid_plain = 10,
      liquid_shiny = 5,
      liquid_metal2 = 5,
      floor_blue2 = 25,
      floor_blue3 = 25,
      floor_trim_liquid = 5,
      floor_mixup = 25,
      floor_shawn_wall = 25,
      floor_shawn_c = 25
    },

    ceiling_sinks =
    {
      sky_shiny = 20,
      sky_metal2 = 20,
      sky_stone_1 = 5,
      sky_stone_2 = 5,
      sky_tech1 = 7,
      sky_tech2 = 7,
      sky_tech3 = 20,
      sky_tech4 = 15,
      sky_tech5 = 10,
      sky_tech6 = 10,
      sky_tech7 = 5,
      sky_tech8 = 10,
      sky_tech9 = 10,
      sky_bronze = 10,
      sky_pipes  = 7,
      sky_cement = 5,
      sky_brownpip = 10,

      light_red_shiny = 40,
      light_orange_shiny = 20,
      light_brightred_metal2 = 20,
      light_side1 = 100,
      light_side2 = 100,
      light_side3 = 100,
      light_side4 = 100,
      light_side5 = 100,
      light_side6 = 100,
      ceil_vdark2 = 30
    },

    passable_decor =
    {
      gibs = 60,
      pool_blood_1 = 10,
      pool_blood_2 = 25,
      pool_brains  = 2,

      gibbed_player = 20,
      dead_player = 35
    },

    beam_groups =
    {
      beam_shiny = 75,
      beam_quakeish = 50,
      beam_lights = 50,
      beam_lights_white = 50,
      beam_lights_vertical_tech = 50,
      beam_textured = 50
    },

    wall_groups =
    {
      low_gap = 10,
      low_gap2 = 10,
      low_gap3 = 10,
      low_gap4 = 10,
      mid_band = 10,
      mid_band2 = 10,
      --
      lite1 = 20,
      lite2 = 20,
      --
      torches4 = 12, --35
      torches5 = 12, --35
      torches6 = 5, --3
      torches7 = 15, --65
      torches11 = 5, --7
      --
      gtd_wall_urban_storage = 50,
      gtd_full_storage = 50,
      --
      gtd_wall_tech_top_corner_light_set = 50,
      gtd_wall_server_room = 50,
      --
      gtd_wall_sewer = 35,
      gtd_sewer_set_2 = 35,
      gtd_sewer_set_3 = 35,
      --
      gtd_water_purifier = 50,
      gtd_toilet_gallery = 25,
      --
      gtd_generic_beamed_inset = 25,
      gtd_generic_beamed_green_inset = 25,
      gtd_generic_beamed_brown_inset = 25,
      --
      gtd_computers = 17,
      gtd_computers_lite5 = 25,
      gtd_computers_blue_shawn = 25,
      --
      gtd_writhing_mass = 10,
      gtd_wall_octagon_insets = 50,
      gtd_wall_grated_machines = 50,
      --
      gtd_wall_quakish_insets = 25,
      gtd_wall_quakish_insets_2 = 25,
      --
      gtd_ribbed_lights = 18,
      gtd_ribbed_lights_no3d = 18,
      gtd_ribbed_lights_slump = 18,
      gtd_ribbed_lights_slump_two_color = 18,
      gtd_ribbed_lights_tekmachine = 9,
      gtd_ribbed_lights_tekmachine_alt = 9,
      gtd_ribbed_lights_very_blue = 18,
      --
      gtd_wall_high_gap_set = 25,
      gtd_wall_high_gap_alt_set = 25,
      --
      gtd_generic_half_floor = 20,
      gtd_generic_half_floor_no_trim = 20,
      gtd_generic_half_floor_inverted_braced = 20,
      --
      gtd_wall_urban_cement_frame = 10,
      --
      gtd_generic_ceilwall = 30,
      gtd_generic_ceilwall_2 = 30,
      gtd_generic_ceilwall_3 = 30,
      gtd_generic_ceilwall_silver_frame = 30,
      gtd_generic_ceilwall_double_silver_frame = 30,
      --
      gtd_generic_glow_wall = 50,
      gtd_generic_double_banded_ceil = 50,
      --
      gtd_generic_frame_light_band = 50,
      gtd_generic_frame_metal = 50,
      --
      gtd_generic_d64_1x = 8,
      gtd_generic_d64_1x_yellow = 8,
      gtd_generic_d64_1x_blue = 8,
      gtd_generic_d64_2x = 8,
      gtd_generic_d64_2x_yellow = 8,
      gtd_generic_d64_2x_blue = 8,
      --
      gtd_generic_tek_grate = 25,
      gtd_generic_tek_grate_bottom_slope = 25,
      gtd_generic_tek_grate_xit_machine = 25,
      --
      gtd_generic_artsy_bedazzled = 5,
      gtd_generic_alt_colors = 20,
      gtd_generic_mid_band = 20,
      gtd_generic_artsy_center_braced_ind = 20,
      gtd_generic_artsy_step1_banded = 20,
      gtd_generic_artsy_slope_y_inset = 20,
      gtd_generic_artsy_base_braced = 20,
      gtd_generic_artsy_sloped_bump = 20,
      gtd_generic_small_lite = 20,
      gtd_generic_artsy_lite_box = 20,
      --
      gtd_ind_modwall_1 = 20,
      gtd_ind_modwall_2 = 20,
      gtd_ind_modwall_3 = 20,
      --
      gtd_greywall_1 = 25,
      gtd_greytall_trim = 25,
      --
      gtd_modquake_set = 18,
      gtd_modquake_jawlike = 18,
      gtd_modquake_top_heavy_brace = 18,
      gtd_modquake_tek_slope_brace = 18,
      gtd_modquake_ex_light_slope_brace = 18,
      gtd_modquake_round_braced_lit_pillar = 18,
      gtd_modquake_hexagon_inset_braced = 18,
      --
      gtd_wall_lamp_stubby = 16,
      gtd_wall_lamp_thin = 16,
      gtd_wall_lamp_thicc = 16,
      --
      gtd_sunderfall = 13,
      gtd_sunderfall_barred = 13,
      gtd_lavafall = 13,
      --
      cran_bunkbeds = 50,
      gtd_craneo_bank_set = 10,
      --
      gtd_mining_set = 50,
      gtd_power_plant_set = 50,
      --
      gtd_DMV_set = 35,
      --
      gtd_door_storage = 25,
      --
      gtd_wall_lit_h_window_tall_gray = 50,
      gtd_wall_lit_h_window_tall_brown = 25
    },

    outdoor_wall_groups =
    {
      PLAIN = 2,
      tech_o_caution_strip = 1,
      tech_o_orange_light_stack = 1,
      tech_o_lite_strip_white = 0.5,
      tech_o_lite_strip_blue = 0.5,
      tech_o_inset_teklite = 0.5,
      tech_o_inset_teklite2 = 0.5,
      tech_o_halfbase_green_light = 0.5,
      tech_o_halfbase_blue_triangle = 0.5,
      tech_o_giant_UAC_sign = 1,
      tech_o_double_hanging_vents = 1,
      tech_o_overhanging_braced_vent = 1,
      tech_o_overhanging_lite_platform = 1,
      tech_o_pipe_junctions = 1,
      tech_o_hadleys_hope = 1,
      tech_o_overhanging_lights = 1,
      tech_o_shiny_silver_overhang = 1,
      tech_o_silver_scaffolding = 1,
      tech_o_concrete_base = 1,
      tech_o_fence_lights_uac_thing = 1,
      tech_o_hex_inset = 1,
      tech_o_grated_greenwall = 1,
      tech_o_everyone_likes_sewers = 1,
      tech_o_red_wall = 0.5,
      tech_o_blue_wall = 0.5,
      tech_o_lots_of_cement = 1,
      tech_o_tekgren_grates_thing = 1,
      tech_o_black_mesa_overlook = 1,
      tech_o_compblue_tall = 1,
      tech_o_grey_metal_sloped = 1,
      tech_o_tall_light = 0.5,
      tech_o_tall_light_alt = 0.5,
      tech_o_hexagon_uac_spotlights = 1,
      tech_o_orange_oct_white_binding = 1,
      tech_o_g_blakwall = 1,
      tech_o_g_modwall1 = 1,
      tech_o_g_modwall2 = 1
    },

    window_groups =
    {
      square = 70,
      tall   = 80,
      grate  = 45,
      barred = 5,
      barred_2 = 10,
      --round  = 5,
      supertall = 60,
      gtd_window_cage_highbars = 20,
      gtd_window_cage_lowbars = 10,
      gtd_window_full_open = 30,
      gtd_window_full_open_tall = 30,
      gtd_window_bay = 20,
      gtd_window_absurdly_open = 25,
      gtd_window_quakeish = 30,
      gtd_window_low = 15,
      gtd_window_bunker_mid_space = 20,
      gtd_window_metal_frames = 30,
      gtd_window_construction_frames = 5,
      gtd_window_hexagon = 30,
      gtd_window_tall_octagon = 25,
      gtd_window_slump_tall = 30,
      gtd_window_industrial_lite_archs = 25,
      gtd_window_dem = 25,
      gtd_window_plut_litebox = 30,
      gtd_window_lite_cross = 15
    },

    fence_groups =
    {
      PLAIN = 50,
      gappy = 50,
      fence_tech_lit = 50,
      fence_corrugated_steel = 50,
      fence_tech_hl_bars = 50,
      fence_sloped_silver = 50,
      fence_highway_bars = 10,
      fence_jurassic_park = 50,
      fence_planters = 10,
      fence_tech_cover = 50
    },

    fence_posts =
    {
      Post_metal = 50,
      Post_tech_1 = 50,
      Post_tech_2 = 50,
      Post_tech_simple = 50
    },

    cave_torches =
    {
      blue_torch  = 20,
      red_torch   = 70,

      lamp = 30,
      mercury_small = 30,
      mercury_lamp  = 10
    },

    outdoor_torches =
    {
      lamp   = 10,
      mercury_lamp  = 40,
      mercury_small = 20
    },

    ceil_light_prob = 70,

    monster_prefs =
    {
      zombie  = 1.5,
      shooter = 1.25,
      gunner  = 1.25,
      imp     = 1.5,
      demon   = 1.25,
      spectre = 1.25,
      knight  = 0.75,
      revenant = 0.5,
      mancubus = 0.6,
      caco    = 0.6,
      baron   = 0.5,
      pain    = 0.4,
      skull   = 0.25,
      vile    = 0.25  --Shouldn't be too many in Tech maps
    },

    style_list =
    {
      caves = { none=75, few=30 },
      outdoors = { none=15, few=40, some=80, heaps=10 },
      beams   = { none=10, few=50, some=20, heaps=5  },
      big_rooms = { none=40, few=25, some=15, heaps=5 },
      big_outdoor_rooms = { none=40, few=5, some=3, heaps=1 },
      hallways = { none=15, few=45, some=20, heaps=10 },
      windows = { few=15, some=85, heaps=40 },
      pictures = { few=20, some=75, heaps=45 },
      liquids = { none=70, few=30, some=10, heaps=5 },
      doors = { few=25, some=75, heaps=30 },
      teleporters = { none=70, few=40, some=10, heaps=3 },
      keys = { none=20, few=80, some=70, heaps=30 },
      trikeys = { none=10, few=60, some=20, heaps=5 },
      switches = { none=25, few=75, some=40, heaps=15 },
      secrets = { few=15, some=80, heaps=30 },
      scenics = { none=10,  few=35, some=60, heaps=20 },
      symmetry = { none=50, few=50, some=50, heaps=50 },
      steepness = { few=30, some=70, heaps=40 },
      cages = { none=70, few=25, some=10, heaps=5 },
      traps = { few=60, some=40, heaps=20 },
      barrels = { few=5, some=85, heaps=60 },
      ambushes = { few=30, some=75, heaps=20 },
      parks   = { none=10 , few=2 , some=1 , heaps=1 },
      park_detail = { none=0, few=15, some=60, heaps=25 },
      porches = { none=5,  few=30, some=60, heaps=15 },
      fences = { none=20, few=40, some=70, heaps=10 }
    },

    scenic_fences =
    {
      MIDBARS3 = 10,
      MIDSPACE = 5,
      MIDBARS1 = 8,
      BRNSMALC = 2
    },

    sink_style =
    {
      sharp = 1,
      curved = 0.1
    },

    skyboxes =
    {
      Skybox_generic = 50,
      Skybox_hellish_city = 50
    },

    techy_doors = true,

    post_mat = "DOORSTOP"
  },

  ------------------------------------

  urban =
  {
    wide_halls = -- Added empty table to use with themes_alt function - Dasho
    {

    },

    narrow_halls =
    {
      vent = 50,
      mineshaft = 50,
      access = 25
    },

    liquids =
    {
      water = 60,
      blood = 40,
      slime = 25,
      nukage = 10,
      lava  = 7
    },

    facades =
    {
      BIGBRIK1 = 40,
      BIGBRIK2 = 30,
      MODWALL1 = 30,
      STONE3   = 30,
      STONE2   = 30,
      CEMENT7  = 20,
      CEMENT9  = 20,
      BRICK12  = 20,
      BRICK7   = 20,
      BRICK5   = 20,
      STONE    = 20,
      BRICK6   = 15,
      BRICK8   = 15,
      BRICK9   = 15,
      STUCCO   = 15,
      BROVINE2 = 10,
      BRICK10 = 10,
      BRICK11 = 10,
      METAL2  = 10,
      GRAYVINE = 10,
      METAL1   = 5,
      BROWN1   = 5,
      BSTONE1  = 10,
      BSTONE2  = 10
    },

    fences =
    {
      BSTONE2  = 60,
      WOOD5    = 60,
      BSTONE1  = 40,
      STONE4   = 30,

      CEMENT9  = 30,
      BRICK12  = 20,
      METAL2   = 20,
      BRICK10  = 10,
      BRICK11  = 10,
      STUCCO   = 10,
      STUCCO3  = 10,

      GRAY5 = 50,
      GRAY7 = 50
    },

    cage_mats =
    {

      WOOD1    = 60,
      PANEL4   = 60,
      MODWALL1 = 60,
      CEMENT9  = 60,
      PIPE4    = 40,
      PANEL1   = 40,
      BROWN1   = 40,
      BROWN144 = 40,
      STONE2   = 20,
      STONE3   = 20,
      WOODVERT = 20,
      METAL2   = 20,
      BSTONE1  = 20
    },

    prefab_remap =
    {
      _STRUCT = "WOODVERT",
      _SMLDOOR = "WOODMET1",
      _TALDOOR = "WOODMET1",
      _BIGDOOR = "BIGDOOR5",
      _KEYTRM1 = "DOORBLU2",
      _KEYTRM2 = "DOORYEL2",
      _KEYTRM3 = "DOORRED2",
      _CRATE = "WOOD12",
      _CRATE2 = "WOOD6",
      _CRATWID = "WOOD8",
      SW1COMP  = "SW1PANEL",
    },

    street_sinks =
    {
      floor_default_streets = 1,
    },

    floor_sinks =
    {
      liquid_plain = 20,
      liquid_metal = 10,
      floor_red = 40,
      floor_blue = 30,
      floor_blue3 = 20,
      floor_green = 20,
      floor_green2 = 15,
      liquid_bstone = 5,
      liquid_bstone2 = 5,
      liquid_ash = 3,
      floor_trim_liquid = 10,
      floor_mixup = 30,
      floor_shawn_wall = 8,
      floor_metal_wall = 15,
      floor_shawn_c = 8,
      floor_metal_c = 15
    },

    ceiling_sinks =
    {
      sky_metal = 25,
      sky_plain = 10,
      sky_modwall = 7,
      sky_stone_1 = 3,
      sky_stone_2 = 3,
      sky_urban_1 = 8,
      sky_urban_2 = 4,
      sky_urban_3 = 8,
      sky_cement = 8,
      sky_brick10 = 5,
      sky_brownpip = 3,

      light_urban1 = 50,
      light_diamond = 10,
      ceil_redash = 12,
      ceil_icky   = 50,
      ceil_vdark  = 30,

      light_side1 = 70,
      light_side2 = 70,
      light_side3 = 70,
      light_side4 = 70,
      light_side5 = 70,
      light_side6 = 70
    },

    beam_groups =
    {
      beam_gothic = 75,
      beam_quakeish = 30,
      beam_lights = 25,
      beam_lights_white = 40,
      beam_lights_vertical_tech = 30,
      beam_wood = 30,
      beam_textured = 50
    },

    wall_groups =
    {
      torches2 = 10, --red
      torches3 = 10, --blue
      torches1 = 10, --green
      torches6 = 8,
      torches9 = 6, --burning barrel
      torches10 = 4, --skull rock
      --
      gtd_wall_urban_storage = 50,
      gtd_full_storage = 50,
      --
      gtd_wall_tech_top_corner_light_set = 50,
      --
      gtd_wall_sewer = 30,
      gtd_sewer_set_2 = 30,
      gtd_sewer_set_3 = 30,
      --
      gtd_water_purifier = 50,
      gtd_toilet_gallery = 25,
      --
      gtd_generic_beamed_inset = 25,
      gtd_generic_beamed_green_inset = 25,
      gtd_generic_beamed_brown_inset = 25,
      --
      gtd_computers = 12,
      gtd_computers_lite5 = 18,
      gtd_computers_blue_shawn = 18,
      --
      gtd_drywall = 50,
      gtd_writhing_mass = 20,
      gtd_library = 50,
      gtd_wall_grated_machines = 20,
      --
      gtd_wall_quakish_insets = 25,
      gtd_wall_quakish_insets_2 = 25,
      --
      gtd_ribbed_lights = 17,
      gtd_ribbed_lights_no3d = 17,
      gtd_ribbed_lights_slump = 17,
      gtd_ribbed_lights_slump_two_color = 17,
      gtd_ribbed_lights_tekmachine = 9,
      gtd_ribbed_lights_tekmachine_alt = 9,
      gtd_ribbed_lights_very_blue = 17,
      --
      gtd_wall_high_gap_set = 25,
      gtd_wall_high_gap_alt_set = 25,
      --
      gtd_generic_half_floor = 16,
      gtd_generic_half_floor_no_trim = 16,
      gtd_generic_half_floor_inverted_braced = 16,
      --
      gtd_woodframe = 15,
      gtd_woodframe_green = 15,
      gtd_woodframe_alt = 15,
      gtd_woodframe_alt_green = 15,
      --
      gtd_round_inset = 15,
      gtd_wall_urban_cement_frame = 25,
      --
      gtd_generic_ceilwall = 30,
      gtd_generic_ceilwall_2 = 30,
      gtd_generic_ceilwall_3 = 30,
      gtd_generic_ceilwall_silver_frame = 30,
      gtd_generic_ceilwall_double_silver_frame = 30,
      --
      gtd_generic_glow_wall = 50,
      gtd_generic_double_banded_ceil = 50,
      --
      gtd_generic_frame_light_band = 50,
      gtd_generic_frame_metal = 50,
      --
      gtd_generic_d64_1x = 10,
      gtd_generic_d64_1x_yellow = 10,
      gtd_generic_d64_1x_blue = 10,
      gtd_generic_d64_2x = 10,
      gtd_generic_d64_2x_yellow = 10,
      gtd_generic_d64_2x_blue = 10,
      --
      gtd_generic_tek_grate = 40,
      gtd_generic_tek_grate_bottom_slope = 40,
      gtd_generic_tek_grate_xit_machine = 40,
      --
      gtd_generic_artsy_bedazzled = 20,
      gtd_generic_alt_colors = 20,
      gtd_generic_mid_band = 20,
      gtd_generic_artsy_center_braced_ind = 20,
      gtd_generic_artsy_step1_banded = 20,
      gtd_generic_artsy_slope_y_inset = 20,
      gtd_generic_artsy_base_braced = 20,
      gtd_generic_artsy_sloped_bump = 20,
      gtd_generic_small_lite = 20,
      gtd_generic_artsy_lite_box = 20,
      --
      gtd_ind_modwall_1 = 20,
      gtd_ind_modwall_2 = 20,
      gtd_ind_modwall_3 = 20,
      --
      gtd_greywall_1 = 25,
      gtd_greytall_trim = 25,
      --
      gtd_modquake_set = 11,
      gtd_modquake_jawlike = 11,
      gtd_modquake_top_heavy_brace = 11,
      gtd_modquake_tek_slope_brace = 11,
      gtd_modquake_ex_light_slope_brace = 11,
      gtd_modquake_round_braced_lit_pillar = 11,
      gtd_modquake_hexagon_inset_braced = 11,
      --
      gtd_wall_lamp_stubby = 7,
      gtd_wall_lamp_thin = 7,
      gtd_wall_lamp_thicc = 7,
      gtd_wall_candalebra = 7,
      gtd_wall_blue_torch = 7,
      gtd_wall_green_torch = 7,
      gtd_wall_red_torch = 7,
      --
      gtd_gothic_ceilwall_arch = 18,
      gtd_gothic_ceilwall_doublet_arch = 18,
      gtd_gothic_ceilwall_braced_arch = 18,
      gtd_gothic_ceilwall_xzibit_arch = 18,
      gtd_gothic_ceilwall_inner_framed_arch = 18,
      --
      gtd_sunderfall = 25,
      gtd_sunderfall_barred = 25,
      gtd_lavafall = 7,
      --
      cran_bunkbeds = 50,
      gtd_craneo_bank_set = 50,
      --
      gtd_mining_set = 35,
      gtd_power_plant_set = 35,
      --
      gtd_DMV_set = 50,
      --
      cran_bloodtubes_set = 50,
      --
      gtd_door_storage = 30,
      --
      gtd_wall_lit_h_window_tall_gray = 25,
      gtd_wall_lit_h_window_tall_brown = 50      
    },

    window_groups =
    {
      barred = 30,
      barred_2 = 20,
      tall   = 95,
      --round  = 30,
      square = 20,
      grate  = 40,
      supertall = 50,
      gtd_window_cage_highbars = 30,
      gtd_window_cage_lowbars = 40,
      gtd_window_arched = 40,
      gtd_window_arched_tall = 20,
      gtd_window_full_open = 70,
      gtd_window_full_open_tall = 65,
      gtd_window_bay = 30,
      gtd_window_absurdly_open = 45,
      gtd_window_quakeish = 20,
      gtd_window_low = 25,
      gtd_window_bunker_mid_space = 25,
      gtd_window_arrowslit = 10,
      gtd_window_weabdows = 70,
      gtd_window_metal_frames = 70,
      gtd_window_pencil_holes = 35,
      gtd_window_construction_frames = 65,
      gtd_window_hexagon = 25,
      gtd_window_tall_octagon = 35,
      gtd_window_slump_tall = 65,
      gtd_window_industrial_lite_archs = 30,
      gtd_window_gothic_archs = 30,
      gtd_window_plut_litebox = 45,
      gtd_window_lite_cross = 20
    },

    fence_groups =
    {
      PLAIN = 50,
      gappy = 50,
      crenels = 12,
      fence_tech_lit = 50,
      fence_gothic = 25,
      fence_corrugated_steel = 50,
      fence_tech_hl_bars = 12,
      fence_sloped_silver = 12,
      fence_highway_bars = 25,
      fence_jurassic_park = 12,
      fence_planters = 40,
      fence_tech_cover = 25
    },

    fence_posts =
    {
      Post_metal = 50,
      Post_tech_1 = 25,
      Post_tech_2 = 25,
      Post_gothic_blue = 10,
      Post_gothic_green = 10,
      Post_gothic_red = 10,
      Post_gothic_blue_2 = 10,
      Post_gothic_green_2 = 10,
      Post_gothic_red_2 = 10
    },

    cave_torches =
    {
      green_torch = 50,
      blue_torch  = 50,
      red_torch   = 50,
      blue_torch_sm = 15,
      red_torch_sm  = 15,
      green_torch_sm = 15,

      lamp = 10,
      candelabra = 10,
      burning_barrel = 20
    },

    outdoor_torches =
    {
      blue_torch = 50,
      red_torch  = 50,
      green_torch = 50,
      candelabra = 30,
      skull_rock = 30,
      blue_torch_sm = 15,
      red_torch_sm  = 15,
      green_torch_sm = 15,
      burning_barrel = 25
    },

    passable_decor =
    {
      gibs = 20,
      pool_blood_1 = 5,
      pool_blood_2 = 15,
      pool_brains  = 3,

      gibbed_player = 15,
      dead_player = 20,
      dead_zombie = 2,
      dead_shooter = 2,
      dead_imp = 2,
      dead_demon = 1,
      dead_caco  = 1
    },

    monster_prefs =
    {
      demon    = 1.2,
      spectre  = 1.1,
      revenant = 1.1,
      knight   = 1.2,
      gunner   = 1.5,
      shooter  = 1.1,
      zombie   = 0.7,
      vile     = 0.6, --Slightly less because multiple Arch-Viles in one area can be a pain in the ass -Chris
      pain     = 0.8,
      mancubus = 1.1,
      Cyberdemon = 1.25
    },

    style_list =
    {
      caves = { none=60, few=40, some=12, heaps=2 },
      outdoors = { none=10, few=35, some=90, heaps=30 },
      big_outdoor_rooms = { none=15, few=40, some=70, heaps=20 },
      pictures = { few=20, some=80, heaps=30 },
      hallways = { none=30, few=80, some=15, heaps=10 },
      windows = { few=25, some=50, heaps=90 },
      cages = { none=30, few=50, some=20, heaps=10 },
      liquids = { none=45, few=30, some=20, heaps=5 },
      doors = { few=20, some=70, heaps=30 },
      beams  = { none=10, few=60, some=40, heaps=10 },
      steepness = { few=25, some=50, heaps=90 },
      big_rooms = { none=25, few=40, some=25, heaps=15 },
      ambushes = { none=5, few=20, some=75, heaps=30 },
      teleporters = { none=20, few=30, some=65, heaps=10 },
      keys = { none=15, few=50, some=50, heaps=20 },
      trikeys = { none=10, few=40, some=80, heaps=20 },
      symmetry = { none=40, few=30, some=35, heaps=25 },
      switches = { none=20, few=60, some=40, heaps=10 },
      secrets = { few=5, some=80, heaps=25 },
      scenics  = { none=5,  few=25, some=40, heaps=80},
      traps   = { none=10, few=40, some=70, heaps=25 },
      barrels = { none=10, few=50, some=20, heaps=5 },
      fences  = { none=5, few=20, some=80, heaps=15 },
      porches = { none=5, few=15, some=80, heaps=50 }
    },

    ceil_light_prob = 65,

    scenic_fences =
    {
      MIDBARS3 = 8,
      MIDSPACE = 8,
      MIDBARS1 = 8,
      BRNSMALC = 2
    },

    sink_style =
    {
      sharp = 1,
      curved = 1
    },

    skyboxes =
    {
      Skybox_hellish_city = 50,
      Skybox_garrett_city = 50
    },

    streets_friendly = true
  },

  ------------------------------------

  hell =
  {
    liquids =
    {
      lava   = 80,
      blood  = 30,
      slime  = 15,
      water  = 10,
      nukage = 5
    },

    entity_remap =
    {
      k_red    = "ks_red",
      k_blue   = "ks_blue",
      k_yellow = "ks_yellow"
    },

    facades =
    {
      MARBGRAY = 60,
      SP_HOT1  = 40,
      GSTONE1  = 40,
      STONE3   = 30,
      SKINMET2 = 20,
      GSTVINE1 = 20,
      GSTVINE2 = 20,
      WOOD3    = 15,
      WOOD5    = 15,
      STONE2   = 10,
      STONE    = 10,
      STUCCO   = 10,
      MARBLE1  = 10,
      MARBLE2  = 10,
      MARBLE3  = 10,
      BSTONE1  = 15,
      BSTONE2  = 15,
      SKINMET1 = 10,
      BROWN1  = 10,
      METAL2  = 5,
      BROWNGRN = 5,
      BROVINE2 = 5
    },

    fences =
    {
      MARBLE3  = 60,
      WOOD5    = 60,
      WOOD3    = 40,
      WOOD1    = 40,
      STONE4   = 40,
      BSTONE2  = 40,
      MODWALL1 = 30,
      MARBGRAY = 30,
      BSTONE1  = 20,
      ICKWALL3 = 20,
      PIPE4    = 20,
      SKIN2    = 20,
      GSTVINE1 = 15,
      GSTVINE2 = 15,
      SP_HOT1  = 15,
      BRICK10  = 10,
      SKINCUT  = 10,
      STUCCO3  = 10
    },

    cage_mats =
    {
     FIREBLU1 = 60,
     FIREBLU2 = 60,
     ICKWALL1 = 60,
     REDWALL  = 60,
     SKSNAKE2 = 60,
     SUPPORT3 = 60,
     BSTONE2  = 40,
     ASHWALL3 = 40,
     MARBGRAY = 40,
     ICKWALL2 = 40,
     MODWALL1 = 40,
     SKINFACE = 40,
     STONE6   = 40,
     ICKWALL3 = 40,
     STONE3   = 40,
     WOOD9    = 40,
     STUCCO3  = 20,
     BROWNHUG = 20,
     SKINCUT  = 20,
     METAL2   = 20,
     ICKWALL7 = 20,
     SKSPINE1 = 20,
     STONE4   = 20,
     TANROCK8 = 20
    },

    prefab_remap =
    {
      DOORBLU  = "DOORBLU2",
      DOORRED  = "DOORRED2",
      DOORYEL  = "DOORYEL2",

      BIGDOOR1 = "BIGDOOR6",
      BIGDOOR2 = "BIGDOOR7",
      BIGDOOR3 = "BIGDOOR7",
      BIGDOOR4 = "BIGDOOR5",

      _STRUCT = "BROWNHUG",
      _SMLDOOR = "WOODMET1",
      _TALDOOR = "WOODMET1",
      _BIGDOOR = "BIGDOOR7",
      _KEYTRM1 = "DOORBLU2",
      _KEYTRM2 = "DOORYEL2",
      _KEYTRM3 = "DOORRED2",
      _NPIC = "SP_FACE2",
      _MPIC = "SKSPINE1",
      _WPIC = "SKINFACE",

      SW1COMP  = "SW1LION",
      SW1PIPE  = "SW1BROWN"
    },

    street_sinks =
    {
      floor_default_streets = 1,
    },

    floor_sinks =
    {
      liquid_plain = 10,
      liquid_blood = 10,
      floor_skulls = 20,
      floor_glowingrock = 12,
      floor_glowingrock2 = 12,
      floor_snakes = 10,
      floor_snakes2 = 7,
      floor_dirt1 = 10,
      floor_dirt2 = 10,
      floor_dirt3 = 10,
      liquid_ash = 5,
      liquid_firelava = 5,
      liquid_bstone = 5,
      liquid_bstone2 = 5,
      liquid_marble = 5,
      floor_sky = 5,
      floor_trim_sky = 7,
      floor_trim_liquid = 8,
      floor_mixup = 17,
      floor_metal_wall = 17,
      floor_metal_c = 17
    },

    ceiling_sinks =
    {
      sky_plain = 20,
      sky_metal = 20,
      sky_stone_1 = 10,
      sky_stone_2 = 10,
      sky_fireblu = 15,
      sky_crackle1 = 10,
      sky_crackle2 = 10,
      ceil_hotrock = 80,
      ceil_hotrock2 = 50,
      ceil_glowrock = 50,
      ceil_glowrock2 = 50,
      ceil_blood = 30,
      ceil_water = 25,
      ceil_sprock = 25,

      sky_hell_1 = 10,
      sky_hell_2 = 10,
      sky_hell_3 = 20,
      sky_hell_4 = 15,
      sky_hell_5 = 20,
      sky_hell_6 = 10,
      sky_hell_7 = 10,
      sky_hell_8 = 10,
      sky_hell_9 = 7,
      sky_hell_10 = 12,
      sky_hell_11 = 12,
      sky_hell_12 = 12,
      sky_hell_13 = 10,
      sky_hell_14 = 15,
      sky_hell_15 = 15,
      sky_cement = 10,
      sky_brick10 = 10,
      sky_metal2 = 10,

      light_diamond = 35,
      light_hell_red = 80,
      light_hell_lava = 40,
      ceil_redash = 25,
      ceil_vdark = 10
    },

    beam_groups =
    {
      beam_gothic = 50,
      beam_quakeish = 50,
      beam_lights_vertical_hell = 50,
      beam_wood = 50,
      beam_textured = 50
    },

    wall_group_prob = 65,

    wall_groups =
    {
      torches2 = 15, --red
      torches3 = 15, --blue
      torches1 = 15, --green
      torches6 = 10, --candelabra
      torches8 = 10, --evil eye
      torches9 = 5,  --burning barrel
      torches10 = 5, --skull rock
      --
      lowhell1 = 16,
      lowhell2 = 16,
      lowhell3 = 16,
      --
      runes1 = 10,
      runes2 = 10,
      runes3 = 10,
      runes4 = 10,
      runes5 = 10,
      --
      cross1 = 7, --7
      cross2 = 15, --15
      cross3 = 7, --7
      cross4 = 10, --5
      cross5 = 15, --10
      --
      mid_band_hell = 2,
      --
      gtd_wall_hell_bloodgutters = 25,
      gtd_wall_tech_top_corner_light_set = 50,
      --
      gtd_generic_beamed_inset = 35,
      gtd_generic_beamed_brown_inset = 35,
      --
      gtd_writhing_mass = 50,
      gtd_library = 50,
      --
      gtd_furnace = 25,
      gtd_furnace_face = 25,
      --
      gtd_wall_marbface = 50,
      gtd_wall_quakish_insets = 50,
      gtd_wall_hell_ossuary = 50,
      --
      gtd_wall_high_gap_set = 25,
      gtd_wall_high_gap_alt_set = 25,
      --
      gtd_generic_half_floor = 20,
      gtd_generic_half_floor_no_trim = 20,
      gtd_generic_half_floor_inverted_braced = 20,
      --
      gtd_woodframe = 15,
      gtd_woodframe_green = 15,
      gtd_woodframe_alt = 15,
      gtd_woodframe_alt_green = 15,
      --
      gtd_round_inset = 50,
      --
      gtd_generic_ceilwall = 30,
      gtd_generic_ceilwall_2 = 30,
      gtd_generic_ceilwall_3 = 30,
      gtd_generic_ceilwall_silver_frame = 30,
      gtd_generic_ceilwall_double_silver_frame = 30,
      --
      gtd_generic_glow_wall = 30,
      gtd_generic_double_banded_ceil = 30,
      --
      gtd_wall_hell_vaults = 50,
      gtd_wall_hell_vaults_ftex = 50,
      --
      gtd_generic_frame_light_band = 50,
      gtd_generic_frame_metal = 50,
      --
      gtd_generic_d64_1x = 10,
      gtd_generic_d64_1x_yellow = 10,
      gtd_generic_d64_1x_blue = 10,
      gtd_generic_d64_2x = 10,
      gtd_generic_d64_2x_yellow = 10,
      gtd_generic_d64_2x_blue = 10,
      --
      gtd_generic_tek_grate = 25,
      gtd_generic_tek_grate_bottom_slope = 25,
      gtd_generic_tek_grate_xit_machine = 25,
      --
      gtd_generic_artsy_bedazzled = 20,
      gtd_generic_alt_colors = 20,
      gtd_generic_mid_band = 20,
      gtd_generic_artsy_center_braced_hell = 20,
      gtd_generic_artsy_step1_banded = 20,
      gtd_generic_artsy_slope_y_inset = 20,
      gtd_generic_artsy_base_braced = 20,
      gtd_generic_artsy_sloped_bump = 20,
      gtd_generic_small_lite = 20,
      gtd_generic_artsy_lite_box = 20,
      --
      gtd_ind_modwall_1 = 20,
      gtd_ind_modwall_2 = 20,
      gtd_ind_modwall_3 = 20,
      --
      gtd_modquake_set = 11,
      gtd_modquake_jawlike = 11,
      gtd_modquake_top_heavy_brace = 11,
      gtd_modquake_tek_slope_brace = 11,
      gtd_modquake_ex_light_slope_brace = 11,
      gtd_modquake_round_braced_lit_pillar = 11,
      gtd_modquake_hexagon_inset_braced = 11,
      --
      gtd_wall_candalebra = 12,
      gtd_wall_blue_torch = 12,
      gtd_wall_green_torch = 12,
      gtd_wall_red_torch = 12,
      --
      gtd_wall_hell_mindscrew = 25,
      gtd_wall_hell_mindscrew_skywall = 25,
      --
      gtd_gothic_ceilwall_arch = 18,
      gtd_gothic_ceilwall_doublet_arch = 18,
      gtd_gothic_ceilwall_braced_arch = 18,
      gtd_gothic_ceilwall_xzibit_arch = 18,
      gtd_gothic_ceilwall_inner_framed_arch = 18,
      --
      gtd_sunderfall = 25,
      gtd_sunderfall_barred = 25,
      gtd_lavafall = 25,
      --
      cran_bloodtubes_set = 50
    },

    outdoor_wall_groups =
    {
      PLAIN = 2,
      hell_o_stone_brace = 1,
      hell_o_wood_brace = 1,
      hell_o_metal_framed_skin = 1,
      hell_o_caged_up_corpses = 1,
      hell_o_giant_stone_faces = 1,
      hell_o_rising_spfaces = 1,
      hell_o_lava_falls = 1,
      hell_o_huge_overhang = 1,
      hell_o_spiny_overhang = 1,
      hell_o_red_glass_tall = 1,
      hell_o_rising_energy = 1,
      hell_o_wooden_palisades = 1,
      hell_o_flying_alcoves = 1,
      hell_o_torch_fenced = 1,
      hell_o_dark_banners = 1,
      hell_o_dark_cathedral_windows = 1,
      hell_o_extruded_arch = 1,
      hell_o_egyptish_triwindows = 1,
      hell_o_destroyed_city_facade = 1,
      hell_o_alt_cathedral_windows = 1,
      hell_o_wood_panel_red_banners = 1,
      hell_o_pencil_arch = 1,
      hell_o_hereticish_arch = 1,
      hell_o_gothic_skin_red = 1,
      hell_o_marb_icon_bfalls = 1,
      hell_o_egyptish = 1,
      hell_o_blood_ocatgon = 1,
      hell_o_catamet = 1,
      hell_o_crematorium_windows = 1,
      hell_o_orange_arch_window = 1,
      hell_o_marble_gargle_stone_pyramid = 1
    },

    window_groups =
    {
      round  = 80, --80,
      tall   = 65, --65,
      barred = 20, --20,
      barred_2 = 20,
      grate  = 40, --40,
      square = 30, --30,
      supertall = 60,
      gtd_window_cage_highbars = 20,
      gtd_window_cage_lowbars = 20,
      gtd_window_cage_hell = 50,
      gtd_window_arched = 60,
      gtd_window_arched_tall = 60,
      gtd_window_arched_inverse = 30,
      gtd_window_full_open = 40,
      gtd_window_full_open_tall = 40,
      gtd_window_absurdly_open = 60,
      gtd_window_quakeish = 30,
      gtd_window_low = 45,
      gtd_window_bunker_mid_space = 50,
      gtd_window_arrowslit = 60,
      gtd_window_metal_frames = 60,
      gtd_window_pencil_holes = 60,
      gtd_window_construction_frames = 60,
      gtd_window_slump_tall = 40,
      gtd_window_industrial_lite_archs = 35,
      gtd_window_gothic_archs = 60,
      gtd_window_tall_octagon = 40,
      gtd_window_dem = 40,
      gtd_window_lite_cross = 30
    },

    fence_groups =
    {
      PLAIN = 50,
      gappy = 50,
      crenels = 50,
      fence_gothic = 50,
      fence_planters = 25
    },

    fence_posts =
    {
      Post_metal = 25,
      Post_gothic_blue = 10,
      Post_gothic_green = 10,
      Post_gothic_red = 15,
      Post_gothic_blue_2 = 10,
      Post_gothic_green_2 = 10,
      Post_gothic_red_2 = 15
    },

    cave_torches =
    {
      red_torch   = 50,
      green_torch = 50,
      blue_torch  = 50,
      blue_torch_sm = 15,
      green_torch_sm = 15,
      red_torch_sm = 15,

      candelabra = 15,
      skull_rock = 15,
      skull_cairn = 20,
      evil_eye   = 10
    },

    outdoor_torches =
    {
      blue_torch = 70,
      red_torch  = 70,
      green_torch = 70,
      candelabra = 30,
      skull_rock = 30,
      blue_torch_sm = 15,
      red_torch_sm  = 15,
      green_torch_sm = 15,
      burning_barrel = 10
    },

    passable_decor =
    {
      gibs = 50,
      pool_blood_1 = 10,
      pool_blood_2 = 30,
      pool_brains  = 3,

      gibbed_player = 20,
      dead_player = 30,
      dead_zombie = 2,
      dead_shooter = 2,
      dead_imp = 1,
      dead_demon = 1,
      dead_caco  = 1
    },

    park_decor =
    {
      burnt_tree = 95,
      brown_stub = 55,
      big_tree = 40,
      evil_eye   = 15,
      skull_rock = 10,
      skull_cairn = 15,
      skull_pole = 10,
      skull_kebab = 10,
      green_pillar = 5,
      green_column  = 5,
      green_column_hrt = 3,
      red_pillar = 5,
      red_column = 5,
      red_column_skl = 3
    },

    style_list =
    {
      doors = { none=15, few=30, some=65, heaps=25 },
      outdoors = { none=10, few=35, some=60, heaps=15 },
      steepness = { few=25, some=70, heaps=40 },
      pictures = { few=50, some=50, heaps=70 },
      big_rooms = { none=25, few=60, some=15, heaps=10 },
      big_outdoor_rooms = { none=25, few=25, some=80, heaps=10 },
      ambushes = { none=10, few=15, some=55, heaps=35 },
      hallways = { none=20, few=60, some=15, heaps=5 },
      teleporters = { none=15, few=25, some=60, heaps=10 },
      keys = { none=15, few=40, some=60, heaps=25 },
      trikeys = { none=10, few=50, some=80, heaps=25 },
      liquids = { none=20, few=45, some=25, heaps=15 },
      traps = { few=20, some=70, heaps=40 },
      switches = { none=25, few=60, some=35, heaps=10 },
      cages    = { none=15, few=25, some=65, heaps=10 },
      symmetry = { none=55, few=25, some=40, heaps=20 },
      secrets = { few=65, some=40, heaps=10 },
      scenics = { none=5,  few=30, some=60, heaps=80},
      caves = { none=60, few=35, some=8, heaps=3 },
      barrels = { none=45, few=15, some=5, heaps=4 },
      porches = { none=0, few=25, some=40, heaps=80 },
      fences  = { none=5, few=15, some=80, heaps=25 },
      beams  = { none=15, few=60, some=30, heaps=10 }
    },

    monster_prefs =
    {
      zombie  = 0.5,
      shooter = 0.75,
      vile    = 1.3,
      imp     = 1.5,
      demon   = 1.3,
      spectre = 1.3,
      skull   = 2.0,
      gunner  = 0.85,
      revenant = 0.8,
      mancubus = 1.2,
      knight = 1.2,
      Cyberdemon = 1.25,
      Mastermind = 1.5
    },

    scenic_fences =
    {
      MIDBRN1 = 3,
      MIDGRATE = 10,
      MIDBARS3 = 8
    },

    sink_style =
    {
      sharp = 0.1,
      curved = 1
    },

    skyboxes =
    {
      Skybox_garrett_hell = 50,
      Skybox_hellish_city = 50
    },

    ceil_light_prob = 40
  }
}



DOOM.ROOM_THEMES =
{

-----  GENERIC STUFF  ------------------------------

  any_vent_Hallway =
  {
    env   = "hallway",
    group = "vent",
    prob  = 1,

    walls =
    {
      GRAY1 = 50,
      GRAY5 = 50,
      ICKWALL1 = 30,
      ICKWALL3 = 30
    },

    floors =
    {
      FLAT1 = 30,
      FLOOR0_3 = 20,
      FLAT20 = 15,
      FLAT3 = 10,
    },

    ceilings =
    {
      FLAT1 = 30,
      FLAT19 = 20,
      FLAT23 = 20,
      FLAT5_4 = 15,
    }
  },


  any_access_Hallway =
  {
    env   = "hallway",
    group = "access",
    prob  = 1,

    walls =
    {
      GRAY1 = 50
    },

    floors =
    {
      FLAT1 = 30
    },

    ceilings =
    {
      FLAT1 = 30
    }
  },

  any_subway_Hallway =
  {
    env   = "hallway",
    group = "subway",
    prob  = 1,

    walls =
    {
      GRAY1 = 50
    },

    floors =
    {
      FLAT1 = 30
    },

    ceilings =
    {
      FLAT1 = 30
    }
  },

  -- For Limit-Removing/generics - Dasho
  any_curve_Hallway =
  {
    env   = "hallway",
    group = "curve",
    prob  = 1,

    walls =
    {
      GRAY1 = 50,
      GRAY5 = 50,
      ICKWALL1 = 30,
      ICKWALL3 = 30
    },

    floors =
    {
      FLAT3 = 30,
      FLOOR0_3 = 10,
      FLAT20  = 15,
      FLAT23 = 20
    },

    ceilings =
    {
      FLAT3 = 30,
      FLAT23 = 15,
      FLAT20 = 20,
      FLAT5_4 = 10,
    }
  },


  any_deuce_Hallway =
  {
    env   = "hallway",
    group = "deuce",
    prob  = 1,

    walls =
    {
      GRAY1 = 50,
      GRAY5 = 50,
      ICKWALL1 = 30,
      ICKWALL3 = 30
    },

    floors =
    {
      FLAT3 = 30,
      FLOOR0_3 = 10,
      FLAT20  = 15,
      FLAT23 = 20
    },

    ceilings =
    {
      FLAT3 = 30,
      FLAT23 = 15,
      FLAT20 = 20,
      FLAT5_4 = 10,
    }
  },


  any_metro_Hallway =
  {
    env   = "hallway",
    group = "metro",
    prob  = 1,

    walls =
    {
      GRAY1 = 50,
      GRAY5 = 50,
      ICKWALL1 = 30,
      ICKWALL3 = 30
    },

    floors =
    {
      FLAT3 = 30,
      FLOOR0_3 = 10,
      FLAT20  = 15,
      FLAT23 = 20
    },

    ceilings =
    {
      FLAT3 = 30,
      FLAT23 = 15,
      FLAT20 = 20,
      FLAT5_4 = 10
    }
  },


  any_mineshaft_Hallway =
  {
    env = "hallway",
    group = "mineshaft",
    prob = 1,

    walls =
    {
      ROCK1 = 50,
      ROCK2 = 50,
      ROCK3 = 50,
      ROCK4 = 50,
      SP_ROCK1 = 50,
      TANROCK5 = 50,
      TANROCK7 = 50
    },

    floors =
    {
      FLAT10 = 50,
      MFLR8_2 = 50,
      MFLR8_3 = 50,
      MFLR8_4 = 50,
      GRNROCK = 50,
      RROCK03 = 50,
      RROCK09 = 50,
      RROCK11 = 50,
      RROCK12 = 50,
      RROCK13 = 50,
      RROCK15 = 50,
      RROCK16 = 50,
      RROCK17 = 50,
      RROCK18 = 50
    },

    ceilings =
    {
      FLAT3 = 50 -- the mineshafts don't actually have
                 -- separate _CEIL textures
    }
  },

-----  TECH BASES  --------------------------------

  tech_Starbase =
  {
    env  = "building",
    prob = 70,

    walls =
    {
      STARTAN2 = 50,
      STARTAN3 = 60,

      STARG1 = 40,
      STARG2 = 20,
      STARG3 = 40,

      STARGR1 = 50,
      STARGR2 = 20,

      STARBR2  = 40
    },

    floors =
    {
      FLOOR4_8 = 50,
      FLOOR5_1 = 50,
      FLOOR5_3 = 30,
      FLOOR0_3 = 30,
      FLOOR5_1 = 25,
      FLOOR3_3 = 20,
      FLOOR0_2 = 20,
      FLOOR0_1 = 20,
      FLOOR4_6 = 15,
      FLOOR7_1 = 15,
      FLAT4 = 15,
      FLAT14 = 10,
      SLIME15 = 10,
      SLIME16 = 10,
      FLOOR1_6 = 6,
      FLOOR1_1 = 8,
      FLOOR0_5 = 5,
      FLAT5 = 5
    },

    ceilings =
    {
      CEIL3_1 = 20,
      CEIL3_2 = 20,
      CEIL3_5 = 20,
      CEIL3_3 = 15,
      CEIL4_2 = 10,
      CEIL4_3 = 10,
      CEIL5_1 = 15,

      FLAT9  = 30,
      FLAT19 = 20,
      FLAT4  = 20,
      FLAT9  = 15,
      FLAT23 = 5
    }
  },


  tech_Tekgren =
  {
    env  = "building",
    prob = 30,

    walls =
    {
      TEKGREN2 = 50,
    },

    floors =
    {
      TKGRASS1 = 50,
      TKGRASS2 = 50,

      FLAT4 = 30,
      FLAT5_4 = 30,
      FLOOR1_1 = 20,
      FLOOR0_3 = 20,
      FLOOR0_5 = 20,
      FLOOR3_3 = 40,
      FLOOR4_6 = 20,
      FLOOR4_8 = 20,
      FLOOR5_1 = 20,
      FLOOR5_3 = 20,
      FLOOR5_4 = 20,
      FLAT5 = 10,

      SLIME14 = 20,
      SLIME16 = 10
    },

    ceilings =
    {
      TKGRASS1 = 50,
      TKGRASS2 = 50,

      FLAT1   = 15,
      CEIL3_5 = 5,
      SLIME15 = 5,
      SLIME14 = 5,

      SLIME14 = 20,
      SLIME16 = 10
    },
  },


  tech_Metal =
  {
    env  = "building",
    prob = 50,

    walls =
    {
      METAL2 = 90,
      METAL1 = 35,
      BRONZE1 = 30,
      BRONZE2 = 15,
      BRONZE3 = 30,
      METAL4 = 15,
      PIPE4 = 10,
    },

    floors =
    {
      FLAT3 = 50,
      FLOOR0_1 = 30,
      FLOOR4_5 = 20,
      FLOOR4_6 = 20,
      FLOOR4_8 = 20,
      FLOOR0_2 = 15,
      FLOOR5_1 = 15,
      FLOOR7_1 = 15,
      SLIME15 = 20,
      SLIME14 = 20,
      CEIL4_1 = 5,
      CEIL4_2 = 5,
    },

    ceilings =
    {
      CEIL5_1 = 40,
      CEIL5_2 = 15,
      SLIME15 = 40,
      CEIL4_1 = 20,
      SLIME14 = 40,
      SLIME16 = 20,
    },
  },


  tech_Gray =
  {
    env  = "building",
    prob = 25,

    walls =
    {
      GRAY1 = 80,
      GRAY5 = 80,
      GRAY4 = 80,
      GRAY7 = 50,
      ICKWALL1 = 10,
      ICKWALL2 = 10,
      ICKWALL3 = 10,
    },

    floors =
    {
      FLAT4 = 50,
      FLOOR0_5 = 40,
      FLOOR0_2 = 20,
      FLOOR3_3 = 20,
      FLOOR4_6 = 15,
      CEIL3_2  = 20,
      FLOOR5_1 = 10,
      FLOOR4_8 = 10,
      FLAT19  = 10,
      SLIME14 = 20,
      SLIME15 = 20,
      SLIME16 = 20,
    },

    ceilings =
    {
      CEIL5_1 = 10,
      CEIL3_1 = 20,
      CEIL3_5 = 20,
      FLAT5_4 = 20,
      FLAT4   = 10,
      SLIME14 = 10,
      SLIME15 = 10,
      SLIME16 = 10,
      FLAT5_5 = 5,
      FLAT1   = 5,
    },
  },


  tech_Sladwall =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      SLADWALL = 50,
    },

    floors =
    {
      FLOOR5_1 = 50,
      FLOOR4_8 = 30,
      FLOOR7_1 = 30,
      FLOOR0_1 = 40,
      FLAT5    = 30,
      FLOOR0_5 = 30,
      SLIME15  = 20,
      FLOOR3_3 = 10,
    },

    ceilings =
    {
      CEIL3_2 = 30,
      CEIL3_5 = 30,
      FLAT1 = 30,
      FLAT4 = 20,
      FLOOR7_1 = 20,
      SLIME14 = 10,
      SLIME15 = 10,
      MFLR8_1 = 5,
    },
  },


  tech_VeryShiny =
  {
    env = "building",
    prob = 10,

    walls =
    {
      SHAWN2 = 50,
    },

    floors =
    {
      FLAT1 = 60,
      FLAT9 = 60,
      FLOOR4_5 = 20,
      CEIL5_1 = 20,
    },

    ceilings =
    {
      FLAT23 = 50,
    },
  },


  tech_VeryTekky =
  {
    env  = "building",
    prob = 10,

    walls =
    {
      TEKWALL4 = 50,
    },

    floors =
    {
      CEIL4_3  = 60,
      FLOOR0_2 = 60,
      FLOOR5_1 = 40,
      SLIME14  = 20,
      CEIL5_1  = 20,
    },

    ceilings =
    {
      CEIL5_1 = 50,
    },
  },


  tech_VeryBluey =
  {
    env = "building",
    prob = 10,

    walls =
    {
      COMPBLUE = 50,
    },

    floors =
    {
      FLAT14 = 30,
      FLOOR1_1 = 10,

      CEIL4_1 = 20,
      CEIL4_2 = 20,

      FLAT4   = 10,
      CEIL5_1 = 20,
    },

    ceilings =
    {
      CEIL5_1 = 40,
      CEIL4_1 = 25,
      CEIL4_2 = 15,

      FLOOR4_1 = 10,
      FLAT23 = 10,
    },
  },


  tech_HighContrast =
  {
    env = "building",
    prob = 10,

    walls =
    {
      BROWNGRN = 15,
      BRONZE1 = 1,
      BRONZE2 = 1,
      BRONZE3 = 1,
      BROWN96 = 1,
    },

    floors =
    {
      FLAT1 = 10,
      FLAT3 = 20,
      FLAT18 = 20,
      FLAT19 = 10,
      FLAT20 = 20,
      FLAT23 = 10,
      FLAT5_4 = 10,
      FLOOR0_3 = 10,
      FLOOR0_5 = 10,
    },

    ceilings =
    {
      FLAT1 = 10,
      FLAT3 = 20,
      FLAT18 = 20,
      FLAT19 = 10,
      FLAT20 = 20,
      FLAT23 = 10,
      FLAT5_4 = 10,
      FLOOR0_3 = 10,
      FLOOR0_5 = 10,
    }
  },

  -- exactly the same Deimos's hellish room -
  -- now available for Doom2 Tech, but very rarely!
  -- note: some Doom1-only textures need to be properly
  -- substituted to their Doom2 variations, or closest possible
  tech_deimosRoom =
  {
    env = "building",
    prob = 15,

    theme_override = "deimos",

    walls =
    {
      MARBLE1 = 15,
      MARBLE2 = 15,
      MARBLE3 = 15,
      BROWNGRN = 15,
      COMPSPAN = 15,
      BROWN1 = 15,
      STARTAN3 = 15,
      STARG3 = 15,
      WOOD1 = 15,
      WOOD3 = 15,
      WOOD5 = 15,
      BROVINE2 = 15,
      ICKWALL3 = 15,
      GRAY7 = 15,
    },

    floors =
    {
      DEM1_5 = 30,
      DEM1_6 = 50,
      FLAT10 = 5,
      FLOOR7_1 = 5,
      FLOOR7_2 = 50,
      FLOOR4_1 = 30,
      FLOOR4_6 = 20,
      FLOOR4_8 = 50,
      FLOOR5_2 = 35,
      FLAT1 = 40,
      FLAT5 = 30,
      FLAT14 = 10,
    },

    ceilings =
    {
      FLOOR7_2 = 50,
      DEM1_5 = 50,
      DEM1_6 = 30,
      FLOOR6_2 = 5,
      CEIL5_1 = 30,
      CEIL3_3 = 50,
      CEIL3_5 = 30,
      CEIL4_1 = 10,
      CEIL4_2 = 10,
    },
  },


  tech_Cave_generic =
  {
    env  = "cave",
    prob = 50,

    walls =
    {
      ZIMMER1  = 20,
      ZIMMER2  = 20,
      ZIMMER3  = 20,
      ZIMMER4  = 20,
      ZIMMER5  = 20,
      ZIMMER7  = 20,
      ZIMMER8  = 40,
      BSTONE1  = 10,
      BSTONE2  = 10,

      ASHWALL2 = 20,
      ASHWALL3 = 20,
      ASHWALL4 = 20,
      ASHWALL6 = 10,
      ASHWALL7 = 10,
      TANROCK4 = 10,
      TANROCK5 = 10,

      STONE4   = 10,
      STONE6   = 10,
    },

    floors =
    {
      ZIMMER8  = 20,
      ZIMMER7  = 20,
      BROWN144 = 30,
      BSTONE1  = 30,

      ASHWALL4 = 20,
      ASHWALL3 = 20,
      ASHWALL2 = 20,
      TANROCK5 = 10,
    },
  },


  tech_Outdoors_generic =
  {
    env  = "outdoor",
    prob = 50,

    floors =
    {
      FLAT1 = 40,
      FLAT3 = 15,
      FLAT5_4 = 15,
      FLOOR0_5 = 15,

      FLOOR0_1 = 5,
      FLOOR0_2 = 5,
      FLOOR0_3 = 15,

      FLOOR3_3 = 5,
      FLOOR4_1 = 4,
      FLOOR4_5 = 4,
      FLOOR4_6 = 5,

      FLOOR5_1 = 10,

      FLOOR5_2 = 3,
      FLOOR7_1 = 5,

      FLAT18 = 5,
      FLAT20 = 5,

      BROWN1 = 10,
      SLIME14 = 5,
      SLIME15 = 6,
      SLIME16 = 5,

      BROWN144 = 85,
    },

    naturals =
    {
      RROCK17  = 50,
      RROCK18  = 50,
      RROCK19  = 50,
      RROCK20  = 50,
      ASHWALL2 = 20,
      ASHWALL3 = 20,
      ASHWALL4 = 20,
      SP_ROCK1 = 70,
      ZIMMER1  = 10,
      ZIMMER2  = 10,
      ZIMMER3  = 10,
      ZIMMER4  = 10,
      ZIMMER5  = 10,
      ZIMMER7  = 10,
      ROCK5    = 20,

      GRASS1 = 60,
      GRASS2 = 60,
    },

    porch_floors =
    {
      FLAT1 = 10,
      FLAT3 = 10,
      FLAT5 = 5,
      FLAT5_4 = 10,
      FLAT19 = 10,
      FLAT20 = 15,
      CEIL5_2 = 15,
      FLOOR0_3 = 10,
      FLOOR0_5 = 10,
      FLOOR3_3 = 8,
      FLOOR4_1 = 8,
      FLOOR4_5 = 8,
      FLOOR5_3 = 10,
      FLOOR7_1 = 15,
      SLIME14 = 10,
      SLIME15 = 10,
      SLIME16 = 10,
    },
  },

  tech_deuce_Hallway =
  {
    env   = "hallway",
    group = "deuce",
    prob  = 50,

    walls =
    {
      TEKGREN1 = 50,
      BROWN1   = 50,
      GRAY7    = 20,

      TEKWALL4 = 20,
      TEKGREN2 = 30,
      STARGR1 = 10,
      STARTAN3 = 15,
      STARG3 = 15,

      PIPEWAL2 = 40,
      PIPE2 = 10,
      PIPE4 = 10,
    },

    floors =
    {
      FLAT4  = 50,
      FLAT14 = 50,
      FLAT1  = 20,
      FLOOR4_8 = 15,
      FLOOR0_2 = 20,
      CEIL4_1 = 20,
    },

    ceilings =
    {
      CEIL3_5 = 50,
      CEIL3_1 = 50,
      RROCK03 = 50,
      CEIL4_2 = 20,
      CEIL5_1 = 40,
    },
  },


  tech_metro_Hallway =
  {
    env   = "hallway",
    group = "metro",
    prob  = 15,

    walls =
    {
      BROWN1 = 50,
      SHAWN2 = 50,
      STARTAN3 = 50,
      STARG3 = 50,
      BROWNGRN = 50,
      BROWN96 = 50,
      BRONZE4 = 50,
      METAL7 = 50,
      COMPBLUE = 50,
    },

    floors =
    {
      FLAT1 = 50,
      FLAT4 = 50,
      FLAT19 = 50,
      FLAT20 = 50,
      FLAT3 = 50,
      FLAT5 = 50,
      FLOOR0_1 = 50,
      FLOOR0_2 = 50,
      FLOOR0_3 = 50,
      FLOOR1_1 = 50,
      FLOOR1_6 = 50,
      FLOOR3_3 = 50,
      FLOOR4_1 = 50,
      FLOOR4_5 = 50,
      FLOOR4_6 = 50,
      FLOOR4_8 = 50,
      FLOOR5_3 = 50,
      SLIME14 = 50,
      SLIME15 = 50,
      SLIME16 = 50,
    },

    ceilings =
    {
      CEIL3_2 = 50,
      CEIL3_3 = 50,
      CEIL3_5 = 50,
      FLAT1 = 50,
      FLAT18 = 50,
      FLAT19 = 50,
      FLAT20 = 50,
      FLAT3 = 50,
      FLOOR3_3 = 50,
      FLOOR4_1 = 50,
      FLOOR4_6 = 50,
      FLOOR4_8 = 50,
      FLOOR5_3 = 50,
      FLOOR5_4 = 50,
      SLIME14 = 50,
      SLIME15 = 50,
      SLIME16 = 50,
    },
  },


  tech_mineshaft_Hallway =
  {
    env = "hallway",
    group = "mineshaft",
    prob = 50,

    walls =
    {
      ROCK1 = 50,
      ROCK2 = 50,
      ROCK3 = 50,
      ROCK4 = 50,
      SP_ROCK1 = 50,
      TANROCK5 = 50,
      TANROCK7 = 50,
      BSTONE1 = 50,
      STONE4 = 50,
      STONE5 = 50,
      STONE6 = 50,
      STONE7 = 50,
    },

    floors =
    {
      FLAT10 = 50,
      MFLR8_2 = 50,
      MFLR8_3 = 50,
      MFLR8_4 = 50,
      GRNROCK = 50,
      RROCK03 = 50,
      RROCK09 = 50,
      RROCK11 = 50,
      RROCK12 = 50,
      RROCK13 = 50,
      RROCK15 = 50,
      RROCK16 = 50,
      RROCK17 = 50,
      RROCK18 = 50,
    },

    ceilings =
    {
      FLAT3 = 50 -- the mineshafts don't actually have
                 -- separate _CEIL textures
    },
  },


----- HELL / GOTHIC -----------------------------


  hell_GreenMarble =
  {
    env  = "building",
    prob = 40,

    walls =
    {
      MARBLE1 = 20,
      MARBLE2 = 50,
      MARBLE3 = 50
    },

    floors =
    {
      GRNROCK  = 30,
      FLAT5_4  = 30,
      FLAT5_1  = 30,
      FLOOR7_1 = 30,
      DEM1_6   = 15,
      FLAT5_1  = 5,
      FLAT5_2  = 5,

      FLAT10   = 10,
      FLOOR6_2 = 10,
      MFLR8_2  = 10
    },

    ceilings =
    {
      FLOOR7_2 = 50,
      DEM1_5   = 20,
      FLOOR6_1 = 20,
      FLOOR6_2 = 20,
      MFLR8_4  = 15
    }
  },

  hell_GrayMarble =
  {
    env  = "building",
    prob = 60,

    walls =
    {
      MARBGRAY = 50
    },

    floors =
    {
      FLOOR7_1 = 50,
      DEM1_5   = 40,
      DEM1_6   = 20,
      FLAT10   = 20,
      FLAT5_4  = 20,
      FLAT5_7  = 20,
      FLAT5_8  = 20,
      FLAT5_1  = 5,
      FLAT5_2  = 5
    },

    ceilings =
    {
      FLOOR7_2 = 60,
      DEM1_5   = 20,
      FLOOR6_1 = 20,
      FLOOR6_2 = 20,
      MFLR8_4  = 15
    },
  },


  hell_gstone =
  {
    prob = 40,
    env = "building",

    walls =
    {
      GSTONE1 = 80,
      GSTVINE1 = 5,
      GSTVINE2 = 5
    },

    floors =
    {
      FLAT1 = 10,
      FLOOR6_2 = 5,
      FLOOR7_1 = 10,
      FLOOR7_2 = 20,
      DEM1_6 = 20,
      DEM1_5 = 20,
      FLAT5_1  = 2,
      FLAT5_2  = 2,
      FLAT1_1 = 2
    },

    ceilings =
    {
      FLAT1 = 5,
      FLAT10 = 3,
      FLOOR6_2 = 3,
      FLOOR7_2 = 30,
      FLOOR6_1 = 3,
      DEM1_5 = 10
    }
  },


  hell_Hotbrick =
  {
    env  = "building",
    prob = 40,

    walls =
    {
      SP_HOT1 = 50
    },

    floors =
    {
      FLAT5_3 = 30,
      FLAT10 = 50,
      FLAT1 = 20,
      FLOOR7_1 = 50,
      FLAT5_7 = 10,
      FLAT5_8 = 10,
      FLOOR6_1 = 10,
      FLOOR6_2 = 5
    },

    ceilings =
    {
      FLOOR6_1 = 20,
      FLOOR6_2 = 20,
      FLAT10 = 15,
      FLAT5_3 = 10
    }
  },


  hell_Stone =
  {
    env  = "building",
    prob = 60,

    walls =
    {
      STONE3 = 50,
      STONE2 = 10
    },

    floors =
    {
      FLOOR6_2 = 30,
      RROCK13  = 30,
      GRNROCK  = 30,
      DEM1_6   = 30,
      SLIME13  = 30
    },

    ceilings =
    {
      RROCK12  = 30,
      RROCK03  = 30,
      MFLR8_2  = 30,
      FLAT5_1  = 30
    }
  },


  hell_Viney =
  {
    env  = "building",
    prob = 10,

    walls =
    {
      GSTVINE2 = 50,
      GSTVINE1 = 10
    },

    floors =
    {
      FLAT1 = 10,
      FLOOR7_1 = 10,
      DEM1_6 = 5,
      DEM1_5 = 5,
      FLOOR7_2 = 10
    },

    ceilings =
    {
      FLAT1 = 5,
      FLOOR7_2 = 20,
      FLOOR6_1 = 3
    }
  },


  hell_Wood =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      WOOD1 = 50,
      WOOD3 = 30,
      WOOD5 = 30,
      WOOD12 = 30,
      WOODVERT = 10
    },

    floors =
    {
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLOOR7_1 = 50,
      FLAT5_4 = 20,
      FLOOR4_6 = 10,
      FLAT5    = 10,
      FLAT1_1  = 10,
      DEM1_6  = 5
    },

    ceilings =
    {
      FLOOR7_2 = 50,
      RROCK14 = 40,
      CEIL1_1 = 30,
      FLAT5_2 = 15,
      FLAT5_7 = 10,
      RROCK13 = 10,
      FLOOR7_1 = 5
    }
  },

  hell_Panel =
  {
    prob = 30,
    env = "building",

    walls =
    {
      PANEL2 = 40,
      PANEL3 = 40,
      PANCASE2 = 25,
      PANEL6 = 20,
      PANEL8 = 35,
      PANEL9 = 35,
      TANROCK3 = 20,
      STUCCO = 15,
      WOOD1 = 5,
      WOOD3 = 5,
      WOOD5 = 5,
      WOOD12 = 5,
      WOODVERT = 5
    },

    floors =
    {
      FLAT5_5 = 50,
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLOOR3_3 = 15,
      FLOOR1_6 = 10,
      FLAT5 = 10,
      DEM1_6 = 3
    },

    ceilings =
    {
      FLAT5_5 = 15,
      CEIL1_1 = 20,
      FLAT5_1 = 25,
      FLAT5_2 = 25,
      FLOOR7_1 = 5
    }
  },


  hell_Skin =
  {
    env  = "building",
    prob = 10,

    walls =
    {
      SKINMET1 = 50,
      SKINMET2 = 50,
      SKINCUT  = 5,
      SKINSYMB = 5
    },

    floors =
    {
      FLAT5_1  = 7,
      FLAT5_2  = 5,
      DEM1_5   = 10,
      DEM1_6   = 10,
      SFLR6_1  = 10,
      FLOOR7_1 = 20,
      FLOOR6_1 = 40,
      SLIME13 = 20
    },

    ceilings =
    {
      SFLR6_1 = 30,
      SFLR6_4 = 30,
      FLAT5_2 = 5,
      FLAT5_3 = 7,
      FLAT5_4 = 5,
      FLOOR7_2 = 10,
      DEM1_5 = 10
    }
  },


  hell_Cave_generic =
  {
    env  = "cave",
    prob = 40,

    walls =
    {
      SP_ROCK1 = 30,

      ASHWALL2 = 30,
      ASHWALL3 = 30,
      ASHWALL4 = 30,
      ASHWALL6 = 30,
      ASHWALL7 = 30,
      STONE4   = 10,
      STONE6   = 15,
      TANROCK5 = 10,
      ROCK1    = 10,
      ROCK2    = 10,
      ROCK3    = 10,
      SKINEDGE = 10,
      CRACKLE4 = 10,
      SKSNAKE1 = 10,
      SKSNAKE2 = 10
    },

    floors =
    {
      MFLR8_3  = 20,
      RROCK16  = 30,
      RROCK09  = 30,

      ASHWALL2 = 30,
      RROCK04  = 20,
      FLOOR6_1 = 20,
      STONE    = 10,

      RROCK02  = 10,
      SKSNAKE1 = 10
    }
  },


  hell_Cave_Hot =
  {
    env  = "cave",
    prob = 60,

    light_adjusts = { 32,48,64 },

    walls =
    {
      ROCKRED1 = 50,
      FIREBLU1 = 15,
      CRACKLE2 =  5,
      CRACKLE4 =  5
    },

    floors =
    {
      FLOOR6_2 = 40,
      FLOOR6_1 = 20,

      RROCK01  = 20,
      RROCK05  = 20,
      RROCK03  = 10,
      RROCK02  = 5
    }
  },


  hell_Outdoors_generic =
  {
    env  = "outdoor",
    prob = 50,

    floors =
    {
      FLAT1_1 = 7,
      FLAT1_2 = 7,
 
      DEM1_5 = 10,
      DEM1_6 = 10,

      FLOOR0_1 = 7,
      FLOOR0_2 = 7,
      FLOOR0_3 = 7,
      FLOOR4_6 = 5,
      FLOOR5_4 = 5,
      FLOOR6_2 = 12,
      FLOOR7_1 = 5,
      FLOOR7_2 = 10,

      FLAT5_7 = 20,
      FLAT5_8 = 10,

      RROCK03 = 30,
      RROCK04 = 30,
      RROCK09 = 15,

      MFLR8_3 = 15,
      SLIME13 = 10,
      SLIME14 = 3,
      SLIME15 = 3,
      SLIME16 = 5,

      RROCK11 = 10,
      RROCK12 = 10,
      RROCK13 = 5,

      RROCK01 = 5,
      RROCK02 = 3
    },

    naturals =
    {
      ROCKRED1 = 50,
      SP_ROCK1 = 30,
      ASHWALL2 = 30,
      ASHWALL3  = 25,
      ASHWALL6  = 20,
      ASHWALL7  = 15,
      ASHWALL4 = 30,
      SKIN2 = 10,
      SKSNAKE1 = 30,
      SKSNAKE2 = 30
    },

    porch_floors =
    {
      CEIL3_5 = 10,
      DEM1_5 = 35,
      DEM1_6 = 35,
      FLAT1_1 = 10,
      FLAT1_2 = 10,
      FLAT5_1 = 35,
      FLAT5_2 = 35,
      FLOOR4_6 = 10,
      FLOOR5_4 = 10,
      MFLR8_1 = 10,
      RROCK09 = 10,
      RROCK12 = 10,
      RROCK13 = 10,
      RROCK14 = 10
    }
  },

  hell_deuce_Hallway =
  {
    env   = "hallway",
    group = "deuce",
    prob  = 100,

    walls =
    {
      MARBGRAY = 80,
      REDWALL  = 60,
      SKIN2    = 60,

      SKSPINE2 = 45,
      SKINSYMB = 45,
      GSTVINE1 = 40,
      GSTVINE2 = 40,
      WOODMET4 = 30,
      WOODMET2 = 25,
      WOODMET1 = 25,
      GSTONE1  = 20,
      SKINMET1 = 10,
      SKINMET2 = 10,

      GSTGARG = 10,
      GSTLION = 10,
      GSTSATYR = 10
    },

    floors =
    {
      FLAT1 = 50,
      DEM1_6  = 30,
      FLOOR6_2 = 15,
      FLOOR7_1 = 20,
      FLOOR7_2 = 25,
      FLAT10  = 20
    },

    ceilings =
    {
      FLAT1 = 50,
      SFLR6_1 = 20,
      SFLR6_4 = 20,
      FLAT5_2 = 10,
      FLOOR7_2 = 20,
      CEIL1_1 = 15,
      BLOOD1 = 20,
      LAVA1 = 15
    },

    y_offsets =
    {
      MARBGRAY = 24,
      SKINSYMB = 30,
      SKINMET1 = 30,
      SKINMET2 = 30,
      SKSPINE2 = 13,
      SW1WOOD  = 47,
      SW1LION  = 47,
      SW1GARG  = 47,
      SW1SATYR  = 47,
      WOODMET4 = 16,
      WOODMET2 = 16,
      WOODMET1 = 16
    }
  },


  hell_vent_Hallway =
  {
    env   = "hallway",
    group = "vent",
    prob  = 50,

    walls =
    {
      WOOD3 = 50,
      WOOD5 = 50,
      WOODMET1 = 50
    },

    floors =
    {
      FLAT5_1 = 50,
      FLAT5_2 = 50
    },

    ceilings =
    {
      CEIL1_1 = 50,
      CEIL3_2 = 50,
      CEIL3_3 = 50
    }
  },


  hell_metro_Hallway =
  {
    env   = "hallway",
    group = "metro",
    prob  = 15,

    walls =
    {
      BROWN1 = 50,
      BIGDOOR5 = 50,
      WOOD1 = 50,
      MARBLE1 = 50,
      FIREBLU1 = 50,
      METAL = 50,
      BROWNHUG = 50,
      GSTONE1 = 50,
      SP_HOT1 = 50
    },

    floors =
    {
      FLOOR7_1 = 50,
      FLOOR7_2 = 50,
      FLOOR5_4 = 50,
      MFLR8_1 = 50,
      MFLR8_2 = 50,
      MFLR8_3 = 50,
      MFLR8_4 = 50,
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLAT1_1 = 50,
      FLAT1_2 = 50,
      DEM1_5 = 50,
      DEM1_6 = 50
    },

    ceilings =
    {
      CEIL3_5 = 50,
      RROCK09 = 50,
      RROCK12 = 50,
      RROCK13 = 50,
      RROCK04 = 50,
      RROCK02 = 50,
      RROCK01 = 50,
      LAVA1 = 50,
      GRNROCK = 50,
      FLOOR6_1 = 50,
      FLOOR6_2 = 50,
      FLOOR7_1 = 50,
      FLOOR7_2 = 50,
      FLAT5_3 = 50,
      FLAT5_4 = 50,
      FLAT5_5 = 50,
      FLAT5_6 = 50,
      FLAT5_7 = 50,
      FLAT5_8 = 50,
      FLAT1_1 = 50,
      FLAT1_2 = 50,
      DEM1_5 = 50,
      DEM1_6 = 50,
      CEIL3_2 = 50,
      CEIL3_5 = 50
    }
  },


  hell_mineshaft_Hallway =
  {
    env = "hallway",
    group = "mineshaft",
    prob = 50,

    walls =
    {
      ROCK1 = 50,
      ROCK2 = 50,
      ROCK3 = 50,
      ROCK4 = 50,
      SP_ROCK1 = 50,
      TANROCK5 = 50,
      TANROCK7 = 50,
      SKIN2 = 50,
      SKINEDGE = 50,
      SKSNAKE1 = 50,
      SKSNAKE2 = 50,
      SKSPINE2 = 50,
      ZIMMER5 = 50,
      ROCKRED1 = 50
    },

    floors =
    {
      FLAT10 = 50,
      FLAT5_6 = 50,
      FLAT5_7 = 50,
      FLAT5_8 = 50,
      FLOOR6_1 = 50,
      FLOOR6_2 = 50,
      FLOOR7_2 = 50,
      MFLR8_2 = 50,
      MFLR8_3 = 50,
      MFLR8_4 = 50,
      RROCK01 = 50,
      RROCK02 = 50,
      RROCK03 = 50,
      RROCK04 = 50,
      RROCK05 = 50,
      RROCK16 = 50,
      SFLR6_1 = 50,
      SFLR6_4 = 50,
      SLIME09 = 50
    },

    ceilings =
    {
      FLAT3 = 50 -- the mineshafts don't actually have
                 -- separate _CEIL textures
    }
  },

----  URBAN / CITY / EARTH  -----------------------


  urban_Brick =
  {
    env  = "building",
    prob = 100,

    walls =
    {
      BIGBRIK1 = 80,
      BIGBRIK2 = 80,

      BRICK12 = 60,
      BRICK5  = 40,
      BRICK6  = 40,
      BRICK7  = 40,

      BRICK2  = 20,
      BRICK8  = 20,
      BRICK1  = 10,
      BRICK9  = 10
    },

    floors =
    {
      FLAT1_1 = 50,
      FLAT1_2 = 30,
      FLAT1   = 30,
      FLAT5   = 15,
      FLAT5_1 = 50,
      FLAT5_2 = 30,
      FLAT5_4 = 20,
      FLAT5_5 = 50,
      FLAT8   = 30,

      FLOOR0_1 = 20,
      FLOOR0_2 = 20,
      FLOOR0_3 = 20,
      FLOOR4_6 = 20,
      FLOOR5_3 = 25,
      FLOOR5_4 = 10
    },

    ceilings =
    {
      FLAT1   = 50,
      FLAT5_4 = 20,
      FLAT5_5 = 15,
      RROCK10 = 20,
      RROCK14 = 20,
      CEIL1_1 = 30,
      FLAT5_2 = 10,
      MFLR8_1 = 10,
      SLIME13 = 5
    }
  },


  urban_Panel =
  {
    env  = "building",
    prob = 50,

    walls =
    {
      PANEL6 = 50,
      PANEL8 = 50,
      PANEL9 = 30,
      PANEL7 = 20,
      PANEL3 = 50,
      PANEL2 = 50,
      PANCASE2 = 30
    },

    floors =
    {
      FLOOR0_2 = 15,
      FLOOR5_3 = 20,
      FLOOR5_4 = 15,
      FLAT1_1 = 30,
      FLAT1_2 = 30,
      FLAT1 = 15,
      FLAT8 = 10,
      FLAT5_5 = 50,
      FLAT5_1 = 40,
      FLAT5_2 = 40,
      FLAT5 = 20,
      FLOOR3_3 = 10,
      FLOOR4_6 = 10
    },

    ceilings =
    {
      FLAT1 = 50,
      CEIL1_1 = 20,
      FLAT5_2 = 20,
      CEIL3_3 = 10,
      RROCK10 = 20,
      RROCK11 = 10,
      FLOOR7_1 = 5,
      CEIL3_5 = 5
    }
  },


  urban_Stone =
  {
    env  = "building",
    prob = 40,

    walls =
    {
      STONE  = 20,
      STONE2 = 60,
      STONE3 = 50,
      ROCK1  = 10,
      ROCK3  = 10
    },

    floors =
    {
      FLAT1_2 = 50,
      FLAT1_1 = 20,
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLAT1 = 50,
      FLAT8 = 20,
      FLAT5_4 = 35,
      FLAT5_5 = 20,
      FLAT5_1 = 50,
      SLIME14 = 15,
      SLIME15 = 15
    },

    ceilings =
    {
      FLAT1 = 50,
      CEIL1_1 = 20,
      CEIL3_5 = 25,
      MFLR8_1 = 30,
      FLAT5_4 = 20,
      RROCK11 = 20,
      RROCK12 = 20,
      FLAT5_2 = 10
    }
  },


  urban_RedBrick =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      BRICK11 = 50
    },

    floors =
    {
      MFLR8_2 = 40,
    
      FLAT1_1 = 40,
      FLAT8 = 30,
      FLOOR0_1 = 10,
      FLOOR0_2 = 10,
      FLOOR0_3 = 10,
      FLOOR0_5 = 30,

      FLOOR3_3 = 20,
      FLOOR4_6 = 20,
      FLOOR5_3 = 10,
      FLOOR5_4 = 20,
      FLOOR6_1 = 10,
      FLOOR6_2 = 10,

      RROCK10 = 40,
      RROCK14 = 40
    },

    ceilings =
    {
      FLOOR5_3 = 10,
      FLOOR5_4 = 20,
      FLOOR6_1 = 30,
      FLAT5_1 = 20,
      FLAT8 = 20,

      CEIL3_3 = 20,
      CEIL3_5 = 20,

      FLAT8 = 10,
      FLAT5_2 = 10,
      FLAT5_4 = 5,

      MFLR8_1 = 5,

      SLIME16 = 20
    }
  },


  urban_GreenBrick =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      BRICK10 = 50,
    },

    floors =
    {
      RROCK14  = 40,
      MFLR8_1  = 40,
      FLAT5_8  = 30,
      FLAT1    = 20,
      FLOOR7_1 = 10,
      FLOOR3_3 = 10
    },

    ceilings =
    {
      GRNROCK  = 40,
      FLOOR7_2 = 20,
      FLAT10   = 20,
      CEIL3_5  = 20,
      CEIL5_1  = 20,
      RROCK13  = 20,
      FLAT8    = 10
    }
  },


  urban_Cement =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      CEMENT7 = 50,
      CEMENT9 = 50,
      GRAY1 = 20,
      GRAY4 = 20,
      GRAY5 = 20,
      GRAY7 = 20,
      GRAYBIG = 20,
      GRAYTALL = 20,
      STONE2 = 15,
      STARG1 = 15,
      STARTAN3 = 15,
      MARBLE1 = 10
    },

    floors =
    {
      FLAT1    = 40,
      FLAT5_4  = 40,
      FLAT3    = 40,
      FLAT10   = 20,
      FLOOR3_3 = 20,
      FLOOR6_2 = 20,
      FLOOR4_8 = 10,
      FLOOR5_1 = 10,
      FLAT5_2 = 5,
      FLAT5_1 = 5
    },

    ceilings =
    {
      FLAT19 = 50,
      FLAT18 = 20,
      FLAT5_4 = 25,
      RROCK13  = 30,
      MFLR8_1  = 30,
      SLIME13  = 20,
      FLOOR7_1 = 10,
      FLAT4    = 10,
      FLAT9 = 5,
      FLAT5_2 = 5,
      CEIL1_1 = 5
    }
  },


  urban_Wood =
  {
    env  = "building",
    prob = 20,

    theme_override = "flesh",

    walls =
    {
      WOOD1 = 50,
      WOOD3 = 30,
      WOOD5 = 30,
      WOOD12 = 30,
      WOODVERT = 10
    },

    floors =
    {
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLOOR7_1 = 50,
      FLAT5_4 = 20,
      FLOOR4_6 = 10,
      FLAT5_5  = 15,
      DEM1_5   = 10,
      DEM1_6   = 15
    },

    ceilings =
    {
      FLOOR7_2 = 50,
      RROCK14 = 40,
      CEIL1_1 = 30,
      FLAT5_2 = 10,
      FLAT5_7 = 10,
      RROCK10 = 10,
      RROCK11 = 10,
      RROCK12 = 10,
      FLOOR7_1 = 5
    }
  },


  urban_Stucco =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      STUCCO3 = 60,
      STUCCO1 = 30,
    },

    floors =
    {
      FLAT5_5  = 50,
      FLAT8    = 20,
      FLOOR4_6 = 25,
      FLOOR5_4 = 20,
      FLAT1_1  = 30,
      FLAT1_2  = 30,
      DEM1_6   = 10,

      FLAT5    = 30,
      CEIL3_5  = 30,
      MFLR8_2  = 20,
      FLOOR1_6 = 10,
      FLAT5_1  = 10,
      FLAT5_2  = 10
    },

    ceilings =
    {
      CEIL1_1  = 30,
      FLAT5_5  = 10,
      FLAT5_2  = 5,

      CEIL3_5  = 30,
      FLAT18   = 20,
      FLAT19   = 30,
      RROCK03  = 10,
      RROCK10  = 10,
      RROCK12  = 5
    }
  },


  -- MSSP: MODWALL3 looks pretty weird
  -- as a regular wall texture now that fabs consistently use them more
  -- thus, this is now the 'brown' theme instead
  urban_BrownyMcBrownston =
  {
    env  = "building",
    prob = 20,

    walls =
    {
      MODWALL1 = 60,
      BROWN1 = 30,
      BROWN144 = 40,
      BROWNHUG = 20,
      BRONZE1 = 20,
      BRONZE3 = 20
    },

    floors =
    {
      FLAT5_4  = 50,
      FLAT8    = 20,
      FLOOR4_6 = 25,
      FLAT1_1  = 30,

      FLAT5    = 30,
      CEIL3_5  = 30,
      MFLR8_2  = 20,
      FLOOR1_6 = 10,
      FLAT5_1  = 10,
      FLAT5_2  = 10
    },

    ceilings =
    {
      CEIL1_1  = 30,
      FLAT5_5  = 10,
      FLAT5_2  = 5,

      CEIL3_5  = 30,
      FLAT18   = 20,
      FLAT19   = 30,
      RROCK03  = 10,
      RROCK10  = 10,
      RROCK12  = 5
    }
  },


  -- MSSP: grey focused stuff, i.e. for the hospital/office look
  urban_ShadesOfGrey =
  {
    env = "building",
    prob = 40,

    walls =
    {
      GRAY1 = 50,
      GRAY4 = 30,
      GRAY5 = 50,
      GRAY7 = 50,
      GRAYTALL = 5,
      STONE2 = 20,

      ICKWALL1 = 10, -- well, some hospitals and offices
      ICKWALL2 = 10 -- have probably fallen into disrepair by now
    },

    floors =
    {
      FLAT1 = 35,
      FLAT18 = 20,
      FLAT19 = 20,
      FLAT20 = 50,
      FLAT3 = 50,
      FLAT4 = 30,
      FLOOR0_3 = 50,
      FLOOR0_5 = 50,

      FLAT14 = 80, -- nice colored carpet look
      FLOOR1_6 = 80,
      FLOOR7_1 = 25,
      CEIL3_3 = 25
    },

    ceilings =
    {
      FLAT18 = 50,
      FLAT19 = 50,
      CEIL5_1 = 10,
      FLAT9 = 20,
      FLOOR0_3 = 20,
      FLOOR0_5 = 20,
      FLAT5_4 = 50
    }
  },

  urban_deuce_Hallway =
  {
    env   = "hallway",
    group = "deuce",
    prob  = 75,

    walls =
    {
      WOOD1    = 90,
      WOOD12   = 90,
      WOOD9    = 90,
      WOODVERT = 90,

      BIGBRIK1 = 50,
      BIGBRIK2 = 50,
      BRICK10  = 50,
      BRICK11  = 10,

      PANEL1   = 50,
      PANEL7   = 30,
      PANEL8   = 30,
      PANEL9   = 30,
      STUCCO   = 30,
      STUCCO1  = 30,
      STUCCO3  = 30
    },

    floors =
    {
      FLAT5_1 = 50,
      FLAT5_2 = 20,
      FLAT8   = 50,
      FLAT5_4 = 50,
      MFLR8_1 = 50,
      FLOOR5_3 = 20,
      FLAT5 = 20
    },

    ceilings =
    {
      CEIL1_1 = 30,
      FLAT5_2 = 25,
      CEIL3_5 = 20,
      MFLR8_1 = 50,
      FLAT1   = 30
    }
  },


  urban_metro_Hallway =
  {
    env   = "hallway",
    group = "metro",
    prob  = 35,

    walls =
    {
      BROWN1 = 50,
      BIGBRIK1 = 50,
      BIGBRIK2 = 50,
      BIGBRIK3 = 50,
      CEMENT7 = 50,
      CEMENT9 = 50,
      PANCASE1 = 50,
      METAL2 = 50,
      BRONZE1 = 50
    },

    floors =
    {
      FLAT1 = 50,
      FLAT4 = 50,
      FLAT19 = 50,
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLAT5_3 = 50,
      FLAT5_4 = 50,
      FLAT5_5 = 50,
      FLAT8 = 50,
      FLOOR0_5 = 50,
      FLOOR4_6 = 50,
      FLOOR5_4 = 50,
      RROCK12 = 50,
      RROCK13 = 50,
      SLIME14 = 50,
      SLIME15 = 50,
      SLIME16 = 50
    },

    ceilings =
    {
      CEIL1_1 = 50,
      CEIL3_1 = 50,
      CEIL3_2 = 50,
      CEIL3_3 = 50,
      CEIL3_5 = 50,
      FLAT20 = 50,
      FLAT3 = 50,
      FLAT5_1 = 50,
      FLAT5_2 = 50,
      FLAT5_4 = 50,
      FLAT5_5 = 50,
      FLOOR0_5 = 50,
      FLOOR3_3 = 50,
      FLOOR4_6 = 50,
      FLOOR5_4 = 50
    }
  },


  urban_mineshaft_Hallway =
  {
    env = "hallway",
    group = "mineshaft",
    prob = 50,

    walls =
    {
      ROCK1 = 50,
      ROCK2 = 50,
      ROCK3 = 50,
      ROCK4 = 50,
      SP_ROCK1 = 50,
      TANROCK5 = 50,
      TANROCK7 = 50,
      STONE4 = 50,
      STONE5 = 50,
      STONE6 = 50,
      STONE7 = 50,
    },

    floors =
    {
      FLAT10 = 50,
      MFLR8_2 = 50,
      MFLR8_3 = 50,
      MFLR8_4 = 50,
      GRNROCK = 50,
      RROCK03 = 50,
      RROCK09 = 50,
      RROCK11 = 50,
      RROCK12 = 50,
      RROCK13 = 50,
      RROCK15 = 50,
      RROCK16 = 50,
      RROCK17 = 50,
      RROCK18 = 50
    },

    ceilings =
    {
      FLAT3 = 50 -- the mineshafts don't actually have
                 -- separate _CEIL textures
    }
  },


  urban_Cave_generic =
  {
    env  = "cave",
    prob = 50,

    walls =
    {
      ROCK1    = 40,
      ROCK2    = 40,
      ROCK3    = 40,
      ASHWALL2 = 40,
      ASHWALL3 = 40,
      ASHWALL4 = 40,

      ZIMMER1  = 10,
      ZIMMER2  = 10,
      ZIMMER3  = 20,
      ZIMMER4  = 20,
      ZIMMER5  = 20,
      ZIMMER7  = 20,
      ROCK5    = 15,

      BSTONE1  = 10,
      BSTONE2  = 10,
      STONE4   = 10,
      STONE5   = 10,
      ASHWALL7 = 10
    },

    floors =
    {
      ROCK2    = 40,
      ASHWALL2 = 40,
      ASHWALL4 = 40,

      ZIMMER1  = 10,
      ZIMMER5  = 20,

      BSTONE2  = 10,
      STONE5   = 10,
      RROCK18  = 20,
      RROCK19  = 20
    }
  },


  urban_Outdoors_generic =
  {
    env  = "outdoor",
    prob = 50,

    floors =
    {
      STONE = 50,
      FLAT1 = 25,
      FLAT3 = 5,
      FLAT18 = 5,
      FLAT20 = 5,

      FLOOR0_1 = 10,
      FLOOR0_2 = 10,
      FLOOR0_3 = 10,

      FLAT5_1 = 7,
      FLAT5_2 = 15,

      FLOOR3_3 = 10,
      FLOOR4_6 = 10,
      FLOOR5_4 = 10,
      FLOOR7_1 = 20,

      RROCK03  = 10,
      MFLR8_3  = 10,
      FLOOR6_2 = 5
    },

    naturals =
    {
      ASHWALL2 = 50,
      ASHWALL3 = 50,
      FLAT10   = 40,
      ASHWALL4 = 50,
      ASHWALL6 = 35,
      ASHWALL7 = 35,
      TANROCK4 = 20,
      TANROCK5 = 20,
      SP_ROCK1 = 20,
      BSTONE1  = 20,
      BSTONE2  = 20,
      ZIMMER1  = 15,
      ZIMMER2  = 15,
      ZIMMER3  = 15,
      ZIMMER4  = 15,
      ZIMMER5  = 15,
      ZIMMER7  = 15,
      ZIMMER8  = 15,
      ROCK1    = 30,
      ROCK2    = 20,
      ROCK3    = 70,

      GRASS1 = 70,
      GRASS2 = 70,
      RROCK18  = 85,
      RROCK19  = 85,
      RROCK17  = 70,
    },

    porch_floors =
    {
      CEIL3_3 = 10,
      CEIL3_5 = 10,
      FLAT1 = 10,
      FLAT1_1 = 10,
      FLAT1_2 = 10,
      FLAT19 = 10,
      FLAT3 = 10,
      FLAT5 = 10,
      FLAT5_1 = 20,
      FLAT5_2 = 20,
      FLAT5_5 = 20,
      FLOOR0_1 = 10,
      FLOOR4_6 = 10,
      FLOOR5_3 = 10,
      FLOOR5_4 = 10,
      FLOOR7_1 = 20,
      MFLR8_1 = 10,
      RROCK14 = 10,
      SLIME14 = 10,
      SLIME15 = 10,
      SLIME16 = 10
    }
  }
}


--------------------------------------------------------------------

DOOM.ROOMS =
{
  GENERIC =
  {
    env = "any"
  },


  ---- Indoors ----

  COMPUTER =
  {
    theme = "tech",
    prob  = 50
  },

  STORAGE =
  {
    prob  = 50
  },

  WASTE =
  {
    theme = "!hell",
    style = "liquids",
    prob  = 50
  },

  PRISON =
  {
    style = "cages",
    prob  = 50
  },

  TORTURE =
  {
    theme = { hell=1, urban=0.2 },
    prob  = 50
  },

  CHAPEL =
  {
    theme = "hell",
    prob  = 15
  },

  LIBRARY =
  {
    theme = "urban",
    prob  = 15
  },


  ---- Outdoors ----

  LAUNCH =
  {
    env = "outdoor",
    theme = "tech",
    prob = 10
  },

  GARDEN =
  {
    env = "outdoor",
    theme = "urban",
    prob = 50
  },

  GRAVEYARD =
  {
    env = "outdoor",
    theme = { hell=1, urban=0.4 },
    prob = 20
  }
}


--------------------------------------------------------------------

DOOM.NAMES =
{
  -- these tables provide *additional* words to those in naming.lua

  TECH =
  {
    lexicon =
    {
      a =
      {
        Deimos=15,
        Phobos=15,
        Ganymede=10,
        Io=10,
        Europa=10,
        Callisto=10,
        Lazarus=10,
        Mimas=10,
        Rhea=10,
        Iapetus=10,
        ["Tei Tenga"]=15
      },

      b =
      {
        UAC=30
      },

      s =
      {
        ["UAC Crisis"]=30
      }
    }
  }
}

--------------------------------------------------------------------

OB_THEMES["tech"] =
{
  label = _("Tech"),
  game = "doomish",
  priority = 50,
  name_class = "TECH",
  mixed_prob = 90,
}


OB_THEMES["urban"] =
{
  label = _("Urban"),
  game = "doom2",
  priority = 30,
  name_class = "URBAN",
  mixed_prob = 35,
}


OB_THEMES["hell"] =
{
  label = _("Hell"),
  game = "doomish",
  priority = 20,
  name_class = "GOTHIC",
  mixed_prob = 35,
}
