------------------------------------------------------------------------
--  STRIFE PARAMETERS and ACTIONS
------------------------------------------------------------------------
--
--  Oblige Level Maker
--
--  Copyright (C) 2006-2015 Andrew Apted
--  Copyright (C) 2011-2012 Jared Blackburn

--  This program is free software; you can redistribute it and/or
--  modify it under the terms of the GNU General Public License
--  as published by the Free Software Foundation; either version 2,
--  of the License, or (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
------------------------------------------------------------------------

STRIFE.PARAMETERS =
{
  teleporters = true,
  rails = true,
  switches = true,
  light_brushes = true,

  max_name_length = 28,

  skip_monsters = { 20,30 },

  time_factor   = 1.0,
  damage_factor = 1.0,
  ammo_factor   = 0.8,
  health_factor = 0.7,

  titlepic_lump   = "TITLEPIC",
  titlepic_format = "patch",

  -- This only works in conjunction with ZDoom's MAPINFO, as DEH/BEX don't work with vanilla Strife (I think)
  bex_map_prefix = "HUSTR_",
}

STRIFE.ACTIONS =
{
  --
  -- These keywords are used by prefabs that are remotely
  -- triggered (by a switch or walk-over line).
  --

  S1_OpenDoor = { id=103,  kind="open" },    -- opens and stays open
  W1_OpenDoor = { id=2,    kind="open" },    --
  GR_OpenDoor = { id=46,   kind="open" },    --

  W1_OpenDoorFast = { id=2, kind="open" },   -- [ Heretic lacks this ]

  S1_RaiseStair = { id=106,  kind="stair" },  -- 16 units
  W1_RaiseStair = { id=107,  kind="stair" },  --

  S1_FloorUp    = { id=18,  kind="floor_up" }, -- up to next highest floor

  S1_LowerFloor = { id=23, kind="lower" },  -- down to lowest nb floor
  W1_LowerFloor = { id=38, kind="lower" }  --
}

STRIFE.MUSIC_LIST =
{
  [1] = "D_ACTION",
  [2] = "D_FAST",
  [3] = "D_DANGER",
  [4] = "D_DARKER",
  [5] = "D_STRIKE",
  [6] = "D_SLIDE",
  [7] = "D_TRIBAL",
  [8] = "D_MARCH",
  [9] = "D_MOOD",
  [10] = "D_CASTLE",
  [11] = "D_FIGHT",
  [12] = "D_SPENSE",
  [13] = "D_DARK",
  [14] = "D_TECH",
  [15] = "D_DRONE",
  [16] = "D_PANTHR",
  [17] = "D_INSTRY"
}